//////////////////////////////////////////////////////////////////////
// Compatibility stuff.
var None = null;

if (Array.prototype.map)
  _map = function(arr, fun /*, thisp */)
  {
     return arr.map(fun, arguments[1]);
  }
else
  _map = function(arr, fun /*, thisp */)
  {
    var len = arr.length;
    if (typeof fun != "function")
      throw new TypeError();

    var res = new Array(len);
    var thisp = arguments[1];
    for (var i = 0; i < len; i++)
    {
      if (i in arr)
        res[i] = fun.call(thisp, arr[i], i, this);
    }

    return res;
  };

function _windowSize()
{
  var d = document;
  if (typeof window.innerWidth != 'undefined')
    return { width: window.innerWidth, height: window.innerHeight };
  else if (d.documentElement
	   && typeof d.documentElement.clientWidth != 'undefined'
	   && d.documentElement.clientWidth != 0)
    return { width: d.documentElement.clientWidth,
	     height: d.documentElement.clientHeight };
  else if (d.body && typeof d.body.clientWidth != 'undefined')
    return { width: d.body.clientWidth, height: d.body.clientHeight };
  else
    return { width: 0, height: 0 };
}

function _grep(list, func)
{
  result = [];
  for (var i = 0; i < list.length; ++i)
  {
    var x = list[i];
    if (func(x))
      result.push(x);
  }
  return result;
}

function _dump(o)
{
    if (typeof(o) == 'object')
  {
    var result = "{ ";
    var joiner = "";
    for (i in o)
    {
      result += joiner + i + ": " + _dump(o[i]);
      joiner = ", ";
    }
    return result + " }";
  }
  else if (typeof(o) == typeof(""))
    return "\"" + o + "\"";
  else
    return "" + o;
}

// Adapted from http://ejohn.org/files/jsdiff.js
// FIXME: http://search.cpan.org/src/NEDKONZ/Algorithm-Diff-1.15/lib/Algorithm/Diff.pm?
function _diff(o, n, f)
{
  var ns = new Object();
  var os = new Object();

  for (var i = 0; i < n.length; i++)
  {
    var x = f(n[i]);
    if (ns[x] == null) ns[x] = { rows: [], o: null };
    ns[x].rows.push(i);
  }

  for (var i = 0; i < o.length; i++)
  {
    var x = f(o[i]);
    if (os[x] == null) os[x] = { rows: [], n: null };
    os[x].rows.push(i);
  }

  for (var i in ns)
    if (ns[i].rows.length == 1
	&& typeof(os[i]) != "undefined"
	&& os[i].rows.length == 1)
    {
      n[ns[i].rows[0]] = { orig: n[ns[i].rows[0]], row: os[i].rows[0] };
      o[os[i].rows[0]] = { orig: o[os[i].rows[0]], row: ns[i].rows[0] };
    }

  for (var i = 0; i < n.length - 1; i++)
    if (n[i].orig != null
	&& n[i+1].orig == null
	&& n[i].row + 1 < o.length
	&& o[n[i].row + 1].orig == null
	&& n[i+1] == o[ n[i].row + 1 ] )
    {
      n[i+1] = { orig: n[i+1], row: n[i].row + 1 };
      o[n[i].row+1] = { orig: o[n[i].row+1], row: i + 1 };
    }

  for (var i = n.length - 1; i > 0; i--)
    if (n[i].orig != null
	&& n[i-1].orig == null
	&& n[i].row > 0
	&& o[n[i].row - 1].orig == null
	&& n[i-1] == o[ n[i].row - 1])
    {
      n[i-1] = { orig: n[i-1], row: n[i].row - 1 };
      o[n[i].row-1] = { orig: o[n[i].row-1], row: i - 1 };
    }

  return { o: o, n: n };
}

function _setval (obj, className, newval)
{
  if (obj.innerHTML != newval)
    obj.innerHTML = newval;
  if (obj.className != className)
    obj.className = className;
}

function _setvaltitle (obj, className, newval, newtitle)
{
  if (obj.innerHTML != newval)
  {
    obj.innerHTML = newval;
    obj.title = newtitle;
  }
  if (obj.className != className)
    obj.className = className;
}

function _settitle (obj, className, newval)
{
  if (obj.title != newval)
    obj.title = newval;
  if (obj.className != className)
    obj.className = className;
}

function _setclass (obj, className)
{
  if (obj.className != className)
    obj.className = className;
}

function _url ()
{
  return location.href.replace(/#.*/, "");
}

function _showOrHide(link,obj,hideLink)
{
  if (typeof(obj) != 'object')
    obj = document.getElementById(obj);

  if (obj.style.display == '')
  {
    obj.style.display = 'none';
    if (hideLink) link.style.display = '';
  }
  else
  {
    obj.style.display = '';
    if (hideLink) link.style.display = 'none';
  }
  return false;
}

function _dblclick(e, data, singleCall, doubleCall)
{
  var _DBL_CLICK_DELAY	 = 100; // No clicks after double click
  var _DBL_CLICK_TIME	 = 250; // Single-to-double click time window

  e.cancelBubble = true;
  if (e.stopPropagation)
    e.stopPropagation();

  var t = new Date().getTime();
  if (e.type == 'click')
  {
    if (t - data.timeDoubleClick < _DBL_CLICK_DELAY)
      return false;
    data.event = { srcElement: (e.srcElement || e.target),
		   type: e.type, x: e.x || e.clientX };
    data.timeClick = t;
    data.timeout = setTimeout(function() {
      	var event = data.event;
      	data.event = null;
      	data.timeClick = 0;
      	data.timeDoubleClick = 0;
      	return (event && singleCall(event));
      }, _DBL_CLICK_TIME);
  }
  else if (e.type == 'dblclick')
  {
    data.timeDoubleClick = new Date().getTime();
    if (data.timeout)
    {
      clearTimeout(data.timeout);
      data.timeout = null;
      data.event = null;
    }
    doubleCall(e);
  }
}

var _WEEKDAY = [ "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" ];
var _MONTH = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun",
	       "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];

function _formatTime(ref, now)
{
  var str = "";
  var future = 0;
  var diff = (now.getTime() - ref.getTime()) / 1000;
  var nowday = now.getDay();
  var refday = ref.getDay();

  if (diff < 0)
  {
    diff = -diff;
    future = 1;
  }

  if (diff < 60 && refday == nowday)
    return sprintf("%d'' %s",
		   diff,
		   future ? "in future" : "ago");

  if (diff < 3600 && refday == nowday)
    return sprintf("%d' %d'' %s",
		   (diff % 3600) / 60,
		   (diff % 60),
		   future ? "in future" : "ago");

  if (diff < 4*3600 && refday == nowday)
    return sprintf("%dh %d' %d'' %s",
		   diff / 3600,
		   (diff % 3600) / 60,
		   (diff % 60),
		   future ? "in future" : "ago");

  if (diff < 86400 && ! future)
    return sprintf("%sat %02d:%02d.%02d",
		   (refday == nowday ? "" : "Yesterday "),
		   ref.getHours(),
		   ref.getMinutes(),
		   ref.getSeconds());

  if (diff < 7*86400 && ! future)
    return sprintf("%s %02d:%02d.%02d",
		   _WEEKDAY[ref.getDay()],
		   ref.getHours(),
		   ref.getMinutes(),
		   ref.getSeconds());

  if (diff < 365*86400 && ! future)
    return sprintf("%s %d, %02d:%02d.%02d",
		   _MONTH[ref.getMonth()],
		   ref.getDate(),
		   ref.getHours(),
		   ref.getMinutes(),
		   ref.getSeconds());

  return sprintf("%s %d, %d, %02d:%02d.%02d",
		 _MONTH[ref.getMonth()],
		 ref.getDate(),
		 ref.getFullYear(),
		 ref.getHours(),
		 ref.getMinutes(),
		 ref.getSeconds());
}

_sanitise = function(str)
{
  if (str)
  {
    str = str.replace(/&/g, "&amp;")
    str = str.replace(/</g, "&lt;")
    str = str.replace(/>/g, "&gt;")
  }
  return str;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
// Install page error handler.
function _pageErrorHandler(msg, url, line)
{
  document.getElementById("messages").innerHTML =
   "<span class='alert'>Please <a href='https://savannah.cern.ch/bugs/"
   + "?group=iguana'>report</a> the following programming error in the"
   + " GUI in " + url + " line " + line + ": " + _sanitise(msg.toString())
   + "</span>";
  return true;
}

window.onerror = _pageErrorHandler;

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
var GUI = new function()
{
  //////////////////////////////////////////////////////////////////////
  // Various parameters.
  var _IDLE_MESSAGE =
    "<span style='font-size: 95%'>"
    + "Please file any feature requests and any bugs you find in <a href='"
    + "https://savannah.cern.ch/bugs/?group=iguana'>Savannah</a>. Find "
    + "<a href='https://twiki.cern.ch/twiki/bin/view/CMS/DQMShiftInstructions'>"
    + "shift instructions here</a>.</span>";

  // Most recent AJAX state.
  var _requestId = 0;
  var _lastRequest = null;
  var _requestQueue = [];
  var _updator;

  // Other state variables.
  var _gui = this;
  var _lasterr = null;
  var _body = document.getElementById("content");
  var _errbody = document.getElementById("errcontent");
  var _messages = document.getElementById('messages');
  var _progressimg = document.getElementById("progress");
  var _lefttop = document.getElementById('sidebar');
  var _timeid = document.getElementById('time');
  var _latencyBase = new Date().getTime();
  var _latency = 1000;
  var _lastCallDuration = 0;
  var _lastDrawDuration = 0;
  var _lastServerDuration = 0;

  // The set of active plugins.
  var _plugins = [];

  // Notify plugins on window resize.
  var _winsize = _windowSize();
  window.onresize = function() {
    var newsize = _windowSize();
    if (newsize.width == _winsize.width
	&& newsize.height == _winsize.height)
      return;

    _winsize = newsize;
    for (var i = 0, e = _plugins.length; i < e; ++i)
      if (_plugins[i].obj.onresize)
	_plugins[i].obj.onresize();
  };

  //////////////////////////////////////////////////////////////////////
  // Available plug-ins will hang off this hook.
  this.Plugin = {};

  //////////////////////////////////////////////////////////////////////
  // Background image loader.  Browsers permit only a small number of
  // HTTP requests, usually 4, to be outstanding at any one time.  If
  // all available HTTP slots have been used to fetch images, AJAX XML
  // HTTP requests are no longer possible until the images have been
  // loaded.  This significantly reduces usability in case of network
  // trouble, slow response time, and when server is unable to serve
  // the images immediately.  This image loader fetches new images in
  // small batches on the background to avoid these problems.  It also
  // highlights images that are being updated so users get feedback on
  // which images are being loaded.
  this.ImgLoader = new function()
  {
    var _IMG_BORDER_NONE     = "1px solid transparent";
    var _IMG_BORDER_LOADING  = "1px dotted #431";
    var _IMG_UPDATE_INTERVAL = 250;
    var _IMG_MAX_LOADING     = 3;
    var _loadstyle	     = 1;
    var _pending             = {};
    var _blank               = FULLROOTPATH + "/static/blank.gif";
    var _missing             = FULLROOTPATH + "/static/missing.png";
    var _imgdiv		     = document.getElementById("imgloader");

    this._flash = function()
    {
      _loadstyle = (_loadstyle+1) % 2;
      for (x in _pending)
      {
	var i = _pending[x];
        i.img.style.border = (_loadstyle ? _IMG_BORDER_LOADING : i.flash);
      }
    }

    this._init = function(img, label, info, src)
    {
      info.loader = img;
      info.img.style.border = _IMG_BORDER_LOADING;
      img.onload = function() { GUI.ImgLoader._onload(img, label, info, 1) };
      img.onerror = function() { GUI.ImgLoader._onload(img, label, info, 0) };
      img.src = src;
    }

    this._startnew = function()
    {
      for (x in _pending)
      {
	var i = _pending[x];
	if (i.loader)
	  continue;

	if (_imgdiv.childNodes.length >= _IMG_MAX_LOADING)
	  break;

	var loader = document.createElement("img");
	loader.width = loader.height = 1;
	loader.style.visibility = 'hidden';
        _imgdiv.appendChild(loader);
	this._init(loader, x, i, i.src);
      }
    }

    this._onload = function(img, label, i, ok)
    {
      if (img.parentNode != _imgdiv)
        return;
      i.img.src = ok ? img.src : _missing;
      i.img.style.border = i.border || _IMG_BORDER_NONE;
      _imgdiv.removeChild(img);
      delete _pending[label];
      GUI.ImgLoader._startnew();
    }
   
    this.reset = function()
    {
      _pending = {};
      while (_imgdiv.firstChild)
      {
	_imgdiv.firstChild.onload = null;
	_imgdiv.firstChild.onerror = null;
	_imgdiv.removeChild(_imgdiv.firstChild);
      }
    }

    this.load = function(label, img, src, border, flash)
    {
      border = border || img.style.border;
      flash = flash || border || _IMG_BORDER_NONE;
      if (label in _pending && _pending[label].loader)
      {
        var i = _pending[label];
	i.loader.onload = null;
	i.loader.onerror = null;
	_imgdiv.removeChild(i.loader);
      }
      _pending[label] = { img: img, src: src, border: border, flash: flash, loader: null };
      img.style.border = flash;
      GUI.ImgLoader._startnew();
    }

    setInterval(this._flash, _IMG_UPDATE_INTERVAL);
    return this;
  }();

  //////////////////////////////////////////////////////////////////////
  // Core GUI functionality.
  this.updateInterval = 15*1000;
  this.makeCall = function(url)
  {
    var id = _requestId++;

    if (_progressimg.style.visibility != 'visible')
      _progressimg.style.visibility = 'visible';

    _lastRequest = YAHOO.util.Connect.asyncRequest
      ("GET", url, { scope: _gui,
		     argument: { id: id, start: new Date().getTime() },
		     success: _gui.updateState,
		     failure: _gui.onFail });
  }

  this.scheduleUpdate = function(multiplier)
  {
    // Keep track of what our latency looks like and report to server.
    var now = new Date().getTime();
    _latency = now - _latencyBase;
    _latencyBase = now;
    clearTimeout(_updator);
    _updator = setTimeout(function() {
	if (! _lastRequest)
	   _gui.makeCall(_url() + "/state?auto="
			 + multiplier*_gui.updateInterval
			 + ";latency=" + _latency
			 + ";call=" + _lastCallDuration
			 + ";server=" + _lastServerDuration
			 + ";render=" + _lastDrawDuration);
      },
      multiplier*_gui.updateInterval);
  }

  this.init = function()
  {
    document.getElementById('body').style.display = '';
    _messages.innerHTML = "Loading content...";
    this.scheduleUpdate(0);
  }

  this.buildLeftSide = function(id, titleName)
  {
    var group = document.createElement('div');
    _lefttop.appendChild(group);

    var title = document.createElement('h3');
    group.appendChild(title);

    var content = document.createElement('div');
    group.appendChild(content);

    group.id = id;
    group.className = 'group';
    title.className = 'group-title';
    content.className = 'group-content';
    title.innerHTML = titleName;
    return group;
  }

  this.updateServerDuration = function(t)
  {
    _lastServerDuration = t;
  }

  this.updateState = function(o)
  {
    try
    {
      GUI.ImgLoader.reset();
      _gui.performUpdateState(o);
    }
    catch (err)
    {
      document.getElementById("messages").innerHTML
        = "<span class='alert'>Please <a href='https://savannah.cern.ch/bugs/"
        + "?group=iguana'>report</a> the following error updating this page: "
        + _sanitise(err.toString()) + "</span>";
    }
  }

  this.performUpdateState = function(o)
  {
    var now = new Date();
    _lastCallDuration = now.getTime() - o.argument.start;
    _lastServerDuration = -1;
    _lastDrawDuration = -1;

    if (o.status != 200)
      return this.onFail (o)

    // If the response is too old, discard it.
    if (o.argument.id < _requestId - 1)
    {
      _messages.innerHTML
	= "(Server responses remaining to catch up with: "
	  + (_requestId - o.argument.id) + ")";
      return;
    }

    // Evaluate the JSON response text.  We get back an array of
    // dictionaries, one per plug-in of content.  We loop over all of
    // these, instantiate the plug-ins if necessary, and then ask each
    // one to refresh its contents.  Once done, clear the message line.
    var response = eval(o.responseText);
    _messages.innerHTML = _IDLE_MESSAGE;
    _timeid.innerHTML = sprintf("; %s %d, %d at %02d:%02d.%02d UTC",
				_MONTH[now.getUTCMonth()],
				now.getUTCDate(),
				now.getUTCFullYear(),
				now.getUTCHours(),
				now.getUTCMinutes(),
				now.getUTCSeconds());

    // First detach unwanted plugins.
    for (var i = 0, e = _plugins.length; i < e; ++i)
    {
      var plugin = _plugins[i];
      if (plugin && (i >= response.length || response[i].kind != plugin.kind))
      {
        plugin.obj.detach();
	_plugins[i] = null;
      }
    }
    _plugins.length = response.length;

    for (var i = 0, e = response.length; i < e; ++i)
    {
      var item = response[i];
      var plugin = _plugins[i];
      if (! plugin)
      {
	// FIXME: menu ordering?
	_plugins[i] = plugin = { kind: item.kind, obj: this.Plugin[item.kind] };
	plugin.obj.attach(this);
      }

      plugin.obj.update(item);
    }

    _lastRequest = null;
    _progressimg.style.visibility = 'hidden';
    _lastDrawDuration = new Date().getTime() - now.getTime();
    this.scheduleUpdate(1);
  }

  this.onFail = function(o)
  {
    // FIXME: Elaborate error message.
    // FIXME: Reinstall (slow) update.
    _lasterr = o;
    this.hideError();

    _lastRequest = null;
    _progressimg.style.visibility = 'hidden';
    this.scheduleUpdate(6);
  }

  this.hideError = function()
  {
    _errbody.style.display = 'none';
    _body.style.display = '';

    _messages.innerHTML
      = "<span class='alert'>Communication failure with the DQM GUI"
	+ " server, HTTP status code was <a href='#' onclick='return GUI.showError()'>"
	+ _lasterr.status + "</a>.</span>";
    return false;
  }

  this.showError = function()
  {
    _body.style.display = 'none';
    _errbody.style.display = '';

    var headers = [];
    for (var i in _lasterr.getResponseHeader)
      headers.push(i);
    headers = headers.sort();

    var content
      = "<div align='center' style='display:block;position:fixed;padding:1em;"
      + " background:#ffffff;left:0;right:0;top:5em;bottom:5em;font-size:1em;"
      + " overflow:auto'>"
      + "<table style='white-space:nowrap'>"
      + "<tr><td colspan='2' style='padding-bottom:2em;font-size:1.5em;"
      + " font-weight:bold'><a href='#' onclick='return GUI.hideError()'>"
      + "Back</a></td></tr>"
      + "<tr valign='top' style='font-size:.85em'><td>Server response</td>"
      + "<td>" + _lasterr.status + " (" + _lasterr.statusText + ")</td></tr>"
      + "<tr valign='top' style='font-size:.85em'><td>Response headers</td>"
      + "<td bgcolor='#eee'>"
      + "<div width='75%' style='overflow:auto;white-space:pre'>";

    for (var i = 0, e = headers.length; i < e; ++i)
      content += headers[i] + ": " + _sanitise(_lasterr.getResponseHeader[headers[i]]) + "\n";

    content += "</pre></td></tr>"
      + "<tr valign='top' style='font-size:.85em'><td>Response text</td>"
      + "<td bgcolor='#eee'>"
      + "<div width='75%' style='overflow:auto;white-space:pre'>"
      + _sanitise(_lasterr.responseText) + "</pre></td></tr>"
      + "</table></div>";
    
    _errbody.innerHTML = content;
    _messages.innerHTML = "";
    return false; 
  }

  return this;
}();

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
GUI.Plugin.AutoUpdate = new function() {
  var _gui = null;
  var _stamp = 0;
  this.attach = function(gui) { _gui = gui; }
  this.detach = function() { }
  this.update = function(state)
  {
    _gui.updateServerDuration(state.serverTime);

    if (state.interval > 0)
      _gui.updateInterval = state.interval * 1000;

    if (! _stamp)
      _stamp = state.stamp;
    else if (_stamp != state.stamp)
      window.location.reload();
  }
}();

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
GUI.Plugin.OverviewHeader = new function() {
  var _gui = null;
  var _data = null;
  var _header = document.getElementById('header');
  var _workspace = null;
  var _view = null;

  this.onresize = function()
  {
    var b = _header.clientHeight;
    for (var i = _header.firstChild; i; i = i.nextSibling)
    {
     var bottom = i.offsetTop + i.clientHeight;
     if (bottom > b)
       b = bottom;
    }

    var top = _header.nextSibling.offsetTop;
    if (top != b)
      _header.nextSibling.style.top = b + 'px';
  }

  this.heading = function(panel, label, content)
  {
    var hdiv = document.createElement("div");
    _header.insertBefore(hdiv, _header.lastChild);
    hdiv.className = 'heading' + (panel ? " with-panel" : "");
    hdiv.innerHTML = ("<div class='label'>" + label + "</div><h2>" + content + "</h2>"
		      + (panel ? "<div class='panel'></div>" : ""));
    return hdiv.childNodes[1];
  }

  this.attach = function(gui)
  {
    var panel;
    _gui = gui;
    _workspace = this.heading(true, "Workspace", "<span>_</span>").firstChild;
    _workspace.parentNode.nextSibling.innerHTML +=
      "<table id='hdr-workspace'><tbody></tbody></table>";
    _view = this.heading(true, "View", "<span>_</span>").firstChild;
    _view.parentNode.nextSibling.innerHTML +=
      "<table id='hdr-view'><tbody></tbody></table>";
    this.onresize();
  }

  this.detach = function()
  {
    _header.removeChild(_workspace.parentNode.parentNode);
    _header.removeChild(_view.parentNode.parentNode);
    _workspace = null;
    _view = null;
  }

  this.setWorkspace = function(choice)
  {
    _gui.makeCall(_url() + "/workspace?name=" + encodeURIComponent(choice));
    return false;
  }

  this.setView = function(choice)
  {
    _gui.makeCall(_url() + "/view?name=" + encodeURIComponent(choice));
    return false;
  }

  this.update = function(data)
  {
    _data = data;
    _workspace.innerHTML = data.workspace;
    _view.innerHTML = data.view;

    var title = data.workspace + " - " + HEADING;
    if (document.title != title)
      document.title = title;

    var table = document.getElementById('hdr-workspace').firstChild;
    var row = table.rows.length ? table.rows[0] : table.insertRow(-1);
    for (var i = 0, e = data.workspaces.length; i < e; ++i)
    {
      var item = data.workspaces[i];
      cell = i < row.cells.length ? row.cells[i] : row.insertCell(-1);

      var text;
      if (item.title != data.workspace)
	text = ("<a href='#' onclick=\"return GUI.Plugin.OverviewHeader"
		+ ".setWorkspace('" + item.label + "')\">" + item.title
		+ "</a>");
      else
	text = item.title;

      if (cell.innerHTML != text)
	cell.innerHTML = text;
    }

    while (row.childNodes.length > data.workspaces.length)
      row.removeChild(row.lastChild);

    var table = document.getElementById('hdr-view').firstChild;
    var row = table.rows.length ? table.rows[0] : table.insertRow(-1);
    for (var i = 0, e = data.views.length; i < e; ++i)
    {
      var item = data.views[i];
      cell = i < row.cells.length ? row.cells[i] : row.insertCell(-1);

      var text;
      if (item.title != data.view)
	text = ("<a href='#' onclick=\"return GUI.Plugin.OverviewHeader"
		+ ".setView('" + item.label + "')\">" + item.title
		+ "</a>");
      else
	text = item.title;

      if (cell.innerHTML != text)
	cell.innerHTML = text;
    }

    while (row.childNodes.length > data.views.length)
      row.removeChild(row.lastChild);
  }

  return this;
}();

GUI.Plugin.PhedexLinkBase = new function()
{
  var _self = this;
  var _gui = null;
  var _gcanvas = document.getElementById('canvas-area');

  this._optPeriodTime = null;
  this._optPeriodSpan = null;
  this._optPeriodUpto = null;
  this._optQuantity = null;
  this._optGrouping = null;
  this._optSrcGrouping = null;
  this._optLinks = null;
  this._optFilterFrom = null;
  this._optFilterTo = null;
  this._optDBProd = null;
  this._optDBDebug = null;
  this._optDBDev = null;
  this._optDBTestbed = null;
  this._optDBTestbed2 = null;

  this.attach = function(gui, linkcontent, preopts, postopts)
  {
    _gui = gui;
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    var content = ""
      + "<table border='0' style='font-size:85%; margin:0 0'><tr valign='top'>"
      + "<td id='link-content'>" + linkcontent + "</td>"

      + "<td style='padding:6em 1em 0 0'>"
      + "<table id='link-options' border='0' style='white-space: nowrap'>"
      + preopts
      + "<tr id='opt-period-time' valign='top'><td>Period</td><td>"
      + "<input style='font-size:100%' id='period-time' type='text' size='4' /> "
      + "<select style='font-size:100%' id='period-span'>"
      + "<option value='hour' selected='selected'>Hours</option>"
      + "<option value='day'>Days</option>"
      + "<option value='week'>Weeks</option>"
      + "<option value='month'>Months</option>"
      + "<option value='year'>Years</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-period-upto' valign='top'><td>Up to</td><td>"
      + "<input style='font-size:100%' id='period-upto' type='text' size='16' />"
      + "</tr>"
      + "<tr id='opt-qty' valign='top'><td>Quantity</td><td>"
      + "<select style='font-size:100%' id='qty'>"
      + "<option value='destination' selected='selected'>Destination</option>"
      + "<option value='source'>Source</option>"
      + "<option value='link'>Link</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-src-grouping' valign='top'><td>Source grouping</td><td>"
      + "<select style='font-size:100%' id='src-grouping' disabled='disabled'>"
      + "<option value='same' selected='selected'>As destination</option>"
      + "<option value='db'>Database instance</option>"
      + "<option value='node'>Storage node</option>"
      + "<option value='site'>Storage site</option>"
      + "<option value='country'>Country</option>"
      + "<option value='region'>Region</option>"
      + "<option value='tier'>Tier</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-grouping' valign='top'><td>Grouping</td><td>"
      + "<select style='font-size:100%' id='grouping'>"
      + "<option value='db'>Database instance</option>"
      + "<option value='node' selected='selected'>Storage node</option>"
      + "<option value='site'>Storage site</option>"
      + "<option value='country'>Country</option>"
      + "<option value='region'>Region</option>"
      + "<option value='tier'>Tier</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-links' valign='top'><td>Tape storage</td><td>"
      + "<select style='font-size:100%' id='links'>"
      + "<option value='nonmss' selected='selected'>Exclude</option>"
      + "<option value='mss'>Just tape</option>"
      + "<option value='all'>Include</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-from-filter' valign='top'><td>From</td><td>"
      + "<input style='font-size:100%' id='from-filter' type='text' size='16' />"
      + "</tr>"
      + "<tr id='opt-to-filter' valign='top'><td>To</td><td>"
      + "<input style='font-size:100%' id='to-filter' type='text' size='16' />"
      + "</tr>"
      + "<tr id='opt-db-sel' valign='top'><td>Databases</td><td>"
      + "Production:<br />"
      + "<input style='font-size:100%; margin-left:2em' id='db-prod' type='checkbox' /> Production<br />"
      + "<input style='font-size:100%; margin-left:2em' id='db-debug' type='checkbox' /> Debug<br />"
      + "Development:<br />"
      + "<input style='font-size:100%; margin-left:2em' id='db-dev' type='checkbox' /> Dev<br />"
      + "<input style='font-size:100%; margin-left:2em' id='db-testbed' type='checkbox' /> Testbed<br />"
      + "<input style='font-size:100%; margin-left:2em' id='db-testbed2' type='checkbox' /> Testbed 2<br />"
      + "</tr>"
      + postopts
      + "</table>"
      + "</td></tr></table>";

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (_gcanvas.style.display != '')
      _gcanvas.style.display = '';

    this._optPeriodTime  = document.getElementById('period-time');
    this._optPeriodSpan  = document.getElementById('period-span');
    this._optPeriodUpto  = document.getElementById('period-upto');
    this._optQuantity    = document.getElementById('qty');
    this._optGrouping    = document.getElementById('grouping');
    this._optSrcGrouping = document.getElementById('src-grouping');
    this._optLinks       = document.getElementById('links');
    this._optFilterFrom  = document.getElementById('from-filter');
    this._optFilterTo    = document.getElementById('to-filter');
    this._optDBProd      = document.getElementById('db-prod');
    this._optDBDebug     = document.getElementById('db-debug');
    this._optDBDev       = document.getElementById('db-dev');
    this._optDBTestbed   = document.getElementById('db-testbed');
    this._optDBTestbed2  = document.getElementById('db-testbed2');

    this._optPeriodTime.onchange  = function() { _self.setPeriod(); return false; }
    this._optPeriodSpan.onchange  = function() { _self.setPeriod(); return false; }
    this._optPeriodUpto.onchange  = function() { _self.setPeriod(); return false; }
    this._optQuantity.onchange    = function() { _self.setOption(this.id, this.value); return false; }
    this._optGrouping.onchange    = function() { _self.setOption(this.id, this.value); return false; }
    this._optSrcGrouping.onchange = function() { _self.setOption(this.id, this.value); return false; }
    this._optLinks.onchange       = function() { _self.setOption(this.id, this.value); return false; }
    this._optFilterFrom.onchange  = function() { _self.setOption('from', this.value); return false; }
    this._optFilterTo.onchange    = function() { _self.setOption('to', this.value); return false; }
    this._optDBProd.onchange      = function() { _self.setDatabases(this.id, this.checked); return false; }
    this._optDBDebug.onchange     = function() { _self.setDatabases(this.id, this.checked); return false; }
    this._optDBDev.onchange       = function() { _self.setDatabases(this.id, this.checked); return false; }
    this._optDBTestbed.onchange   = function() { _self.setDatabases(this.id, this.checked); return false; }
    this._optDBTestbed2.onchange  = function() { _self.setDatabases(this.id, this.checked); return false; }
  }

  this.detach = function()
  {
    this._optPeriodTime = null;
    this._optPeriodSpan = null;
    this._optPeriodUpto = null;
    this._optQuantity = null;
    this._optGrouping = null;
    this._optSrcGrouping = null;
    this._optLinks = null;
    this._optFilterFrom = null;
    this._optFilterTo = null;
    this._optDBProd = null;
    this._optDBDebug = null;
    this._optDBDev = null;
    this._optDBTestbed = null;
    this._optDBTestbed2 = null;
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.setOption = function(option, value)
  {
    _gui.makeCall(_url()
		  + "/alter?opt=" + encodeURIComponent(option)
		  + ";val=" + encodeURIComponent(value));
  }

  this.setPeriod = function()
  {
    _gui.makeCall(_url() + "/period"
		  + "?span=" + encodeURIComponent(this._optPeriodSpan.value)
		  + ";time=" + encodeURIComponent(this._optPeriodTime.value)
		  + ";upto=" + encodeURIComponent(this._optPeriodUpto.value));
  }

  this.setDatabases = function(changed, checked)
  {
    _gui.makeCall(_url() + "/databases"
		  + "?prod="     + (this._optDBProd.checked ? "yes" : "no")
		  + ";debug="    + (this._optDBDebug.checked ? "yes" : "no")
		  + ";dev="      + (this._optDBDev.checked ? "yes" : "no")
		  + ";testbed="  + (this._optDBTestbed.checked ? "yes" : "no")
		  + ";testbed2=" + (this._optDBTestbed2.checked ? "yes" : "no"));
  }

  this.selectOption = function(sel, item, def)
  {
    for (var i = 0, n = sel.firstChild; n; n = n.nextSibling, ++i)
      if (n.value == item)
      {
	sel.selectedIndex = i;
	return;
      }

    sel.selectedIndex = def;
  }

  this.optionValue = function(sel)
  {
    return encodeURIComponent(sel.childNodes[sel.selectedIndex].value);
  }

  this.update = function(data, info)
  {
    if (data['period.time'] != null)
      this._optPeriodTime.value = data['period.time'];

    if (data['period.upto'] != null)
      this._optPeriodUpto.value = data['period.upto'];

    this.selectOption(this._optPeriodSpan, data['period.span'], 0);
    this.selectOption(this._optQuantity, data['qty'], 0);
    this.selectOption(this._optGrouping, data['grouping'], 1);
    this.selectOption(this._optSrcGrouping, data['src-grouping'], 0);
    this.selectOption(this._optLinks, data['links'], 0);

    if (this._optQuantity.selectedIndex != 2)
    {
      this._optGrouping.parentNode.previousSibling.innerHTML = "Grouping";
      this._optSrcGrouping.disabled = true;
    }
    else
    {
      this._optGrouping.parentNode.previousSibling.innerHTML = "Destination grouping";
      this._optSrcGrouping.disabled = false;
    }

    if (data['filter.from'] != null)
      this._optFilterFrom.value = data['filter.from'];

    if (data['filter.to'] != null)
      this._optFilterTo.value = data['filter.to'];

    this._optDBProd.checked = (data['db.prod'] == 'yes');
    this._optDBDebug.checked = (data['db.debug'] == 'yes');
    this._optDBDev.checked = (data['db.dev'] == 'yes');
    this._optDBTestbed.checked = (data['db.testbed'] == 'yes');
    this._optDBTestbed2.checked = (data['db.testbed2'] == 'yes');

    info.dbsel = (data['db.prod'] == 'yes' ? "prod" : "")
	         + (data['db.debug'] == 'yes' ? "+debug" : "")
	         + (data['db.dev'] == 'yes' ? "+dev" : "")
	         + (data['db.testbed'] == 'yes' ? "+testbed" : "")
	         + (data['db.testbed2'] == 'yes' ? "+testbed2" : "");
    if (info.dbsel == "")
      info.dbsel = "none";

    info.suffix = ""
      + "?session=" + SESSION_ID
      + ";version=" + data.version
      + ";span=" + this.optionValue(this._optPeriodSpan)
      + ";end=" + data['end']
      + ";start=" + data['start']
      + ";qty=" + this.optionValue(this._optQuantity)
      + ";grouping=" + this.optionValue(this._optGrouping)
      + ";src-grouping=" + this.optionValue(this._optSrcGrouping)
      + ";links=" + this.optionValue(this._optLinks)
      + ";from=" + encodeURIComponent(this._optFilterFrom.value)
      + ";to=" + encodeURIComponent(this._optFilterTo.value)
  }

  return this;
}();

GUI.Plugin.PhedexLinkImage = new function()
{
  var _self = this;
  var _imgPlot = null;
  var _imgLegend = null;
  var _optPlotSize = null;

  this.base = GUI.Plugin.PhedexLinkBase;
  this.attach = function(gui)
  {
    var content = ""
      + "<img id='plot' width='800' height='600' style='margin:1em 0 0' /><br />"
      + "<img id='legend' width='800' style='margin:0 0 1em' />"
    var preopts = ""
      + "<tr id='opt-plot-size' valign='top'><td>Plot format</td><td>"
      + "<select style='font-size:100%' id='plot-size'>"
      + "<option value='1600 1200 72'>Extra large</option>"
      + "<option value='800 600 72' selected='selected'>Large</option>"
      + "<option value='600 450 60'>Medium</option>"
      + "<option value='400 300 42'>Small</option>"
      + "</select>"
      + "</tr>";
    var postopts = ""
      + "<tr id='opt-download' valign='top'><td>Download</td><td>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexLinkImage.download(this.textContent)'>PDF</a>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexLinkImage.download(this.textContent)'>EPS</a>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexLinkImage.download(this.textContent)'>SVG</a>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexLinkImage.download(this.textContent)'>JSON</a>"
      + "</tr>";

    this.base.attach(gui, content, preopts, postopts);

    _imgPlot       = document.getElementById('plot');
    _imgLegend     = document.getElementById('legend');
    _optPlotSize   = document.getElementById('plot-size');
    _optPlotSize.onchange = function() { _self.base.setOption('size', this.value); return false; }
  }

  this.detach = function()
  {
    _imgPlot = null;
    _imgLegend = null;
    _optPlotSize = null;
    this.base.detach();
  }

  this.download = function(format)
  {
    // FIXME: Plot and legend?
    window.location.href = _imgPlot.src + ";type=" + format.toLowerCase();
    return false;
  }

  this.update = function(data, image, info)
  {
    this.base.update(data, info);

    var w = data['size.width'];
    var h = data['size.height'];
    var dpi = data['size.dpi'];
    var whd = '800 600 72';
    if (w && h && dpi)
    {
      info.suffix += ';width=' + w + ";height=" + h + ";dpi=" + dpi;
      _imgLegend.width = w;
      _imgPlot.width = w;
      _imgPlot.height = h;
      whd = w + ' ' + h + ' ' + dpi;
    }

    this.base.selectOption(_optPlotSize, whd, 1);

    GUI.ImgLoader.load("plot", _imgPlot, ROOTPATH + "/plotfairy/phedex/"
		       + info.dbsel + "/" + image + ":plot" + info.suffix);
    GUI.ImgLoader.load("legend", _imgLegend, ROOTPATH + "/plotfairy/phedex/"
		       + info.dbsel + "/" + image + ":legend" + info.suffix);
  }

  return this;
}();

GUI.Plugin.PhedexLinkRate = new function()
{
  this.base = GUI.Plugin.PhedexLinkImage;
  this.attach = function(gui) { this.base.attach(gui); }
  this.detach = function() { this.base.detach(); }
  this.update = function(data) { this.base.update(data, "link-rate", {}); }
  return this;
}();

GUI.Plugin.PhedexLinkBytes = new function()
{
  this.base = GUI.Plugin.PhedexLinkImage;
  this.attach = function(gui) { this.base.attach(gui); }
  this.detach = function() { this.base.detach(); }
  this.update = function(data) { this.base.update(data, "link-bytes", {}); }
  return this;
}();

GUI.Plugin.PhedexRateQuality = new function()
{
  this.base = GUI.Plugin.PhedexLinkImage;
  this.attach = function(gui) { this.base.attach(gui); }
  this.detach = function() { this.base.detach(); }
  this.update = function(data) { this.base.update(data, "rate-vs-quality", {}); }
  return this;
}();

GUI.Plugin.PhedexBlockLatency = new function()
{
  var _self = this;
  var _imgPlot = null;
  var _optPlotSize = null;
  var _optPlotDetail = null;
  var _optRangeUnit = null;
  var _optRangeLinLog = null;
  var _optRangeBins = null;
  var _optRangeYMin = null;
  var _optRangeYMax = null;

  this.base = GUI.Plugin.PhedexLinkBase;
  this.attach = function(gui)
  {
    var content = ""
      + "<img id='plot' width='800' height='600' style='margin:1em 0 0' />"
    var preopts = ""
      + "<tr id='opt-plot-size' valign='top'><td>Plot format</td><td>"
      + "<select style='font-size:100%' id='plot-size'>"
      + "<option value='1600 1200 72'>Extra large</option>"
      + "<option value='800 600 72' selected='selected'>Large</option>"
      + "<option value='600 450 60'>Medium</option>"
      + "<option value='400 300 42'>Small</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-plot-detail' valign='top'><td>Detail</td><td>"
      + "<select style='font-size:100%' id='plot-detail'>"
      + "<option value='completed-block-latency-summary' selected='selected'>Block completion latency</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-range' valign='top'><td>Units</td><td>"
      + "<select style='font-size:100%' id='range-unit'>"
      + "<option value='time' selected='selected'>Time only</option>"
      + "<option value='time-vs-size'>Time vs. size</option>"
      + "</select> "
      + "<select style='font-size:100%' id='range-linlog'>"
      + "<option value='lin'>Linear</option>"
      + "<option value='log' selected='selected'>Logarithmic</option>"
      + "</select>"
      + "</tr>"
      + "<tr id='opt-range-bins' valign='top'><td>Bins</td><td>"
      + "<input style='font-size:100%' id='range-bins' type='text' size='4' />"
      + "</tr>"
      + "<tr id='opt-range-minmax' valign='top'><td style='padding-bottom:2em'>Y limits</td><td>"
      + "<input style='font-size:100%' id='range-ymin' type='text' size='4' /> - "
      + "<input style='font-size:100%' id='range-ymax' type='text' size='4' />"
      + "</tr>";
    var postopts = ""
      + "<tr id='opt-download' valign='top'><td>Download</td><td>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexBlockLatency.download(this.textContent)'>PDF</a>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexBlockLatency.download(this.textContent)'>EPS</a>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexBlockLatency.download(this.textContent)'>SVG</a>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexBlockLatency.download(this.textContent)'>JSON</a>"
      + "</tr>";

    this.base.attach(gui, content, preopts, postopts);

    _imgPlot        = document.getElementById('plot');
    _optPlotSize    = document.getElementById('plot-size');
    _optPlotDetail  = document.getElementById('plot-detail');
    _optRangeUnit   = document.getElementById('range-unit');
    _optRangeLinLog = document.getElementById('range-linlog');
    _optRangeBins   = document.getElementById('range-bins');
    _optRangeYMin   = document.getElementById('range-ymin');
    _optRangeYMax   = document.getElementById('range-ymax');

    _optPlotSize.onchange    = function() { _self.base.setOption('size', this.value); return false; }
    _optPlotDetail.onchange  = function() { _self.base.setOption('detail', this.value); return false; }
    _optRangeUnit.onchange   = function() { _self.base.setOption('range-unit', this.value); return false; }
    _optRangeLinLog.onchange = function() { _self.base.setOption('range-linlog', this.value); return false; }
    _optRangeBins.onchange   = function() { _self.base.setOption('range-bins', this.value); return false; }
    _optRangeYMin.onchange   = function() { _self.base.setOption('range-ymin', this.value); return false; }
    _optRangeYMax.onchange   = function() { _self.base.setOption('range-ymax', this.value); return false; }

    document.getElementById('opt-qty').style.display = 'none';
    document.getElementById('opt-src-grouping').style.display = 'none';
    document.getElementById('opt-from-filter').style.display = 'none';
    this.base._optQuantity.selectedIndex = 0;
    this.base._optSrcGrouping.selectedIndex = 0;
    this.base._optFilterFrom.value = '';
  }

  this.detach = function()
  {
    _imgPlot = null;
    _optPlotSize = null;
    _optPlotDetail = null;
    this.base.detach();
  }

  this.download = function(format)
  {
    // FIXME: Plot and legend?
    window.location.href = _imgPlot.src + ";type=" + format.toLowerCase();
    return false;
  }

  this.update = function(data)
  {
    var info = {};
    this.base.update(data, info);

    var w = data['size.width'];
    var h = data['size.height'];
    var dpi = data['size.dpi'];
    var whd = '800 600 72';
    if (w && h && dpi)
    {
      info.suffix += ';width=' + w + ";height=" + h + ";dpi=" + dpi;
      _imgPlot.width = w;
      _imgPlot.height = h;
      whd = w + ' ' + h + ' ' + dpi;
    }

    this.base.selectOption(_optPlotSize, whd, 1);
    this.base.selectOption(_optPlotDetail, data['detail'], 0);
    this.base.selectOption(_optRangeUnit, data['range.unit'], 0);
    this.base.selectOption(_optRangeLinLog, data['range.linlog'], 1);

    if (data['range.bins'] != null)
      _optRangeBins.value = data['range.bins'];
    if (data['range.ymin'] != null)
      _optRangeYMin.value = data['range.ymin'];
    if (data['range.ymax'] != null)
      _optRangeYMax.value = data['range.ymax'];

    info.suffix += ""
      + ";unit=" + this.base.optionValue(_optRangeUnit)
      + ";timerep=" + this.base.optionValue(_optRangeLinLog)
      + ";bins=" + encodeURIComponent(_optRangeBins.value)
      + ";ymin=" + encodeURIComponent(_optRangeYMin.value)
      + ";ymax=" + encodeURIComponent(_optRangeYMax.value);

    GUI.ImgLoader.load("plot", _imgPlot, ROOTPATH + "/plotfairy/phedex/"
		       + info.dbsel + "/" + _optPlotDetail.value
		       + ":plot" + info.suffix);
  }

  return this;
}();

GUI.Plugin.PhedexRegionCrossRate = new function()
{
  var _self = this;
  var _header = null;
  var _body = null;
  var _data = null;

  this.base = GUI.Plugin.PhedexLinkBase;
  this.attach = function(gui)
  {
    var content = ""
      + "<iframe id='phedex-data'"
      + " onload='GUI.Plugin.PhedexRegionCrossRate.refill()'"
      + " style='visibility:hidden;position:fixed;top:-5px;left:-5px'"
      + " width='0' height='0'></iframe>"
      + "<table style='margin:1em 0;padding-right:1em;border-right:1px solid #ddd' border='0' cellpadding='3'>"
      + "<thead><tr id='phedex-table-header'></tr></thead>"
      + "<tbody id='phedex-table-body'></tbody>"
      + "</table>";
    var postopts = ""
      + "<tr valign='top'><td>Download</td><td>"
      + " <a href='#' onclick='return GUI.Plugin.PhedexRegionCrossRate.download()'>JSON</a>"
      + "</tr>";

    this.base.attach(gui, content, "", postopts);
    document.getElementById('link-options').parentNode.style.padding = '1.4em 0 0 0';
    document.getElementById('link-options').style.marginLeft = '1em';

    _header = document.getElementById('phedex-table-header');
    _body = document.getElementById('phedex-table-body');
    _data = document.getElementById('phedex-data');
  }

  this.detach = function()
  {
    _header = null;
    _body = null;
    _data = null;
    this.base.detach();
  }

  this.download = function()
  {
    window.location.href = _data.src;
    return false;
  }

  this.refill = function()
  {
    var body = "";
    var header = "<th>To \\ From</th>";
    var frame = (_data.contentDocument || document.frames[_data.id].document);
    var data = eval(frame.body.firstChild.innerHTML);
    for (var i = 0, e = data.regions.length; i < e; ++i)
    {
      header += "<th>" + data.regions[i] + "</th>";
      body += "<tr><th>" + data.regions[i] + "</th>";
      for (var j = 0; j < e; ++j)
	body += sprintf("<td align='right' bgcolor='%s'>%.1f</td>",
			(i == j ? "#ffc" : "#fff"),
			data.table[data.regions[i]][data.regions[j]])
      body += "</tr>";
    }

    if (_header.innerHTML != header)
      _header.innerHTML = header;
    if (_body.innerHTML != body)
      _body.innerHTML = body;
  }

  this.update = function(data)
  {
    var info = {};
    this.base.update(data, info);
    var frames = document.getElementsByTagName("iframe");
    for (var i = 0, e = frames.length; i < e; ++i)
      frames[i].src = ROOTPATH + "/plotfairy/phedex/" + info.dbsel + "/region-cross-rate:info" + info.suffix;
  }

  return this;
}();

GUI.Plugin.CAFSystemSummary = new function()
{
  var _gcanvas = document.getElementById('canvas-area');

  this.attach = function(gui)
  {
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    var content = ""
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>Availability</h3>"
      + "<img id='i-caf-avail' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/avail' /><br />"
      + "<img id='i-caf-free' style='margin:-0.75em 0 1em' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/disk-free' /><br />"
      + "<img id='i-caf-freepct' style='margin:-0.75em 0 1em' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/disk-freepct' />"
      + "</div>"
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>System utilisation</h3>"
      + "<img id='i-caf-use-cpu' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/sysuse-cpu' /><br />"
      + "<img id='i-caf-use-net' style='margin:-.75em 0 1em' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/sysuse-net' /><br />"
      + "</div>";

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (_gcanvas.style.display != '')
      _gcanvas.style.display = '';
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.update = function(data)
  {
    for (var i = 0, e = document.images.length; i < e; ++i)
    {
      var img = document.images[i];
      if (img.src.indexOf("/plotfairy/") >= 0)
      {
	var baseurl = img.src.replace(/\?.*/, "");
	GUI.ImgLoader.load("img" + i, img, baseurl + "?session="
			   + SESSION_ID + ";version=" + data.version);
      }
    }
  }

  return this;
}();

GUI.Plugin.CAFJobSummary = new function()
{
  var _gcanvas = document.getElementById('canvas-area');

  this.attach = function(gui)
  {
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    var content = ""
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>Jobs running at CAF</h3><img id='i-jobs-all' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-all' />"
      + "<h3>All CMSPHYS jobs</h3><img id='i-jobs-phys' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-cmsphys' />"
      + "</div>"
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>All CMSCOMM jobs</h3><img id='i-jobs-comm' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-cmscomm' />"
      + "<h3>All CMSALCA jobs</h3><img id='i-jobs-alca' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-cmsalca' />"
      + "</div>";

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (_gcanvas.style.display != '')
      _gcanvas.style.display = '';
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.update = function(data)
  {
    for (var i = 0, e = document.images.length; i < e; ++i)
    {
      var img = document.images[i];
      if (img.src.indexOf("/plotfairy/") >= 0)
      {
	var baseurl = img.src.replace(/\?.*/, "");
	GUI.ImgLoader.load("img" + i, img, baseurl + "?session="
			   + SESSION_ID + ";version=" + data.version);
      }
    }
  }

  return this;
}();

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
GUI.Plugin.DQMHeaderRow = new function() {
  var _gui = null;
  var _data = null;
  var _header = document.getElementById('header');
  var _service = null;
  var _runGroup = null;
  var _runNr = null;
  var _lumiNr = null;
  var _eventNr = null;
  var _workspace = null;
  var _pageNr = null;
  var _npage = 1;
  var _npages = 1;

  this.onresize = function()
  {
    var b = _header.clientHeight;
    for (var i = _header.firstChild; i; i = i.nextSibling)
    {
     var bottom = i.offsetTop + i.clientHeight;
     if (bottom > b)
       b = bottom;
    }

    var top = _header.nextSibling.offsetTop;
    var newtop = b+15;
    if (top != newtop)
      _header.nextSibling.style.top = newtop + 'px';
  }

  this.heading = function(panel, label, content)
  {
    var hdiv = document.createElement("div");
    _header.insertBefore(hdiv, _header.lastChild);
    hdiv.className = 'heading' + (panel ? " with-panel" : "");
    hdiv.innerHTML = ("<div class='label'>" + label + "</div><h2>" + content + "</h2>"
		      + (panel ? "<div class='panel'></div>" : ""));
    return hdiv.childNodes[1];
  }

  this.attach = function(gui)
  {
    var panel;
    _gui = gui;
    _service = this.heading(true, "DQM service",
			    "<span>_</span>:").firstChild;
    _service.parentNode.nextSibling.innerHTML +=
      "<table id='hdr-service'><tbody></tbody></table>";

    _runNr = this.heading(true, "Run",
			  "<span>_</span><span class='delimiter'>"
			  + "&nbsp;&nbsp;.</span>").firstChild;
    _lumiNr = this.heading(false, "LS",
			   "<span>_</span><span class='delimiter'>"
			   + "&nbsp;&nbsp;.</span>").firstChild;
    _eventNr = this.heading(false, "Event",
			    "<span>_</span><span class='delimiter'>"
			    + "&nbsp;&nbsp;.</span>").firstChild;
    _runNr.parentNode.nextSibling.innerHTML += "<table id='hdr-runnr' style='font-size:.9em'><tbody>"
      +"<tr><td><input style='font-size:100%' type='text' onKeyUp='return GUI.Plugin.DQMHeaderRow.runNrKeyPress(event)'/>"
          +" &nbsp; &nbsp; <span style='font-size: small'></span></td></tr>"
        +"<tr><td><div></div></td></tr>"
        +"<tr><td><div></div></td></tr>"
      +"</tbody></table>";

    _workspace = this.heading(true, "Workspace",
			      "<span>_</span>,").firstChild;
    _workspace.parentNode.nextSibling.innerHTML +=
      "<table id='hdr-workspace' style='font-size:.9em'><tbody valign='top'></tbody></table>";

    _pageNr = this.heading(true, "Page",
			   "<span class='delimiter'><a href='#'"
			   + " onclick='return GUI.Plugin.DQMHeaderRow.movePage(-1)'>"
			   + "<img width='20' height='15' src='"
			   + FULLROOTPATH + "/static/left.gif'/></a></span>"
			   + "<span>1 / 1</span>"
			   + "<span class='delimiter'><a href='#'"
			   + " onclick='return GUI.Plugin.DQMHeaderRow.movePage(1)'>"
			   + "<img width='20' height='15' src='"
			   + FULLROOTPATH + "/static/right.gif'/></a></span>").childNodes[1];
    _pageNr.parentNode.nextSibling.innerHTML +=
      ("Go to page <input style='font-size:100%' id='hdr-pagenr' size='4' type='text'"
       + " onchange='return GUI.Plugin.DQMHeaderRow.setPage(this.value)' />");
  }

  this.detach = function()
  {
    _header.removeChild(_service.parentNode.parentNode);
    _header.removeChild(_runNr.parentNode.parentNode);
    _header.removeChild(_lumiNr.parentNode.parentNode);
    _header.removeChild(_eventNr.parentNode.parentNode);
    _header.removeChild(_workspace.parentNode.parentNode);
    _header.removeChild(_pageNr.parentNode.parentNode);
    _service = null;
    _runNr = null;
    _lumiNr = null;
    _eventNr = null;
    _workspace = null;
    _pageNr = null;
  }

  this.movePage = function(by)
  {
    var page = _npage + by;
    if (page > _npages) page = 1;
    if (page < 1) page = _npages;
    _gui.makeCall(_url() + "/setPage?page=" + page);
    return false;
  }

  this.setPage = function(choice)
  {
    _gui.makeCall(_url() + "/setPage?page=" + encodeURIComponent(choice));
    return false;
  }

  this.setWorkspace = function(choice)
  {
    _gui.makeCall(_url() + "/workspace?name=" + encodeURIComponent(choice));
    return false;
  }

  this.setRun = function(choice)
  {
    _gui.makeCall(_url() + "/setRun?n=" + encodeURIComponent(choice));
    return false;
  }

  this.update = function(data)
  {
    _data = data;
    _service.innerHTML = data.service;
    _workspace.innerHTML = data.workspace;
    _runNr.innerHTML = data.run;
    _lumiNr.innerHTML = data.lumi;
    _eventNr.innerHTML = data.event;
    _pageNr.innerHTML = data.page + " / " + data.pages;

    var title = data.service + " - " + data.workspace + " - " + HEADING;
    if (document.title != title)
      document.title = title;

    document.getElementById('hdr-pagenr').value = data.page;

    var table, row, cell;
    table = document.getElementById('hdr-service').firstChild;
    for (var i = 0, e = data.services.length; i < e; ++i)
    {
      var item = data.services[i];
      row = i < table.rows.length ? table.rows[i] : table.insertRow(-1);
      cell = row.cells.length ? row.cells[0] : row.insertCell(-1);

      var text;
      if (item.title != data.service)
	text = "<a href='" + item.href + "'>" + item.title + "</a>";
      else
	text = item.title;

      if (cell.innerHTML != text)
	cell.innerHTML = text;
    }

    var category = null;
    table = document.getElementById('hdr-workspace').firstChild;
    row = table.rows.length ? table.rows[0] : table.insertRow(-1);
    data.workspaces.sort(function(a, b) {
      if (a.rank != b.rank)
        return a.rank - b.rank;
      else if (a.title < b.title)
        return -1;
      else if (a.title > b.title)
        return 1;
      else
        return 0;
    });
    for (var c = 0, i = 0, e = data.workspaces.length; i < e; ++i)
    {
      var item = data.workspaces[i];
      if (item.category != category)
      {
        category = item.category;
        cell = c < row.cells.length ? row.cells[c] : row.insertCell(-1);
	cell.innerHTML = "<b style='color:#722'>" + item.category + "</b><br />";
	++c;
      }

      var text;
      if (item.title != data.workspace)
	text = ("<a href='#' onclick=\"return GUI.Plugin.DQMHeaderRow"
		+ ".setWorkspace('" + item.label + "')\">" + item.title
		+ "</a>");
      else
	text = item.title;

      if (i < e-1)
        text += "<br />";

      cell.innerHTML += text;
    }

    this.runNrUpdate(data.runs);

    _npage = data.page;
    _npages = data.pages;
    this.onresize();
  }
  
  this.runNrData = {
    _input:         null,
    _info:          null,
    _header:        null,
    _body:          null,
    _maxHeaderCols: 5,
    _maxBodyRows:   2,
    _maxBodyCols:   10,
    _maxIBodyRuns:   null,
    _runList:       [],
    _index:         null,
    _keyword:       null,
    _matches:       0,
    _exactMatch:    false,
    _isFirstPage:   true,
    _lastkwd:       null
  };
  
  this.runNrUpdate = function (list)
  {
    var r = this.runNrData;
    if (r._input == null)
    {
      var _runNrTable = document.getElementById("hdr-runnr").firstChild;
      r._input  = _runNrTable.rows[0].cells[0].firstChild;
      r._info   = _runNrTable.rows[0].cells[0].lastChild;
      r._header = _runNrTable.rows[1].cells[0].firstChild;
      r._body   = _runNrTable.rows[2].cells[0].firstChild;
      r._maxIBodyRuns = r._maxBodyCols * r._maxBodyRows;
    }
    if (list != undefined)
      r._runList = list;
    r._keyword = r._input.value.replace(/\s/g, "");
    r._hasParent = (r._keyword.length != 0);
    this.runNrIndexer();
    this.runNrDrawPanel();
    return false;
  }
  
  this.runNrKeyPress = function (evt)
  {
    var key = null;
    var r   = this.runNrData;
    if (evt.which) key = evt.which;
    else if (window.event) key = evt.keyCode;
    if (key == 13 && r._exactMatch)
    {
      GUI.Plugin.DQMHeaderRow.setRun(r._input.value.replace(/\s/g, ""))
    }
    else
    {
      r._keyword = r._input.value.replace(/\s/g, "");
      r._hasParent = (r._keyword.length != 0);
      this.runNrIndexer();
      this.runNrDrawPanel();
    }

  }
  
  this.runNrClick = function (kw)
  {
    var r = this.runNrData;
    r._lastkwd = r._keyword;
    r._keyword = (kw == undefined) ? "" : kw.toString();
    if (r._lastkwd != kw)
      r._isFirstPage = true;
    r._hasParent   = (r._keyword.length != 0);
    r._input.value = r._keyword;
    this.runNrIndexer();
    this.runNrDrawPanel();
    return false;
  }
    
  this.runNrNextPage = function()
  {
    this.runNrData._isFirstPage = (!this.runNrData._isFirstPage);
    this.runNrDrawPanel();
    return false;
  }
  
  this.runNrIndexer = function ()
  {
    var r = this.runNrData;
    var kw = r._keyword;
    var lst = r._runList;
    var idx = r._index = {};
    r._matches = 0;
    r._exactMatch = null;
    var rx  = new RegExp("^(" + kw + ")(.)");
    for (var i = 0; i < lst.length; ++i)
    {
      var str = lst[i].toString();
      var m   = rx.exec(str);
      if (m)
      {
        if (! idx[m[2]])
          idx[m[2]] = [];
        idx[m[2]].push(str);
        ++r._matches;
      }
      else if (kw == str)
        r._exactMatch = str;
    }
  }
  
  this.runNrHighLight = function (ch, isOn)
  {
    var color = (isOn) ? "#FFFF00" : "";
    var runs = document.getElementsByName("runset"+ch);
    for (var i = 0; i < runs.length; ++i)
      runs[i].style.backgroundColor = color;
  }
  
  this.runNrDrawPanel = function ()
  {
    var r = this.runNrData;
    var idx = r._index;
    var kw  = r._keyword;
    
    // result message of query
    var msg = "";
    if (kw.length == 0)
      msg += r._matches+" runs, ";
    else
    {
      if (r._exactMatch)
        msg += "[" + r._exactMatch + "] is an exact match, ";
      if (r._matches)
        msg += " " + r._matches.toString() + " match, ";
      if (!r._exactMatch && r._matches == 0)
        msg = "no runs match, ";
    }

    // initialize header & body html text
    var headerHTML = "";
    var bodyHTML   = "";
    var arrowUp    = "";
    var arrowLeft  = "<img src='"+FULLROOTPATH+"/static/runleft.gif'/>";
    var arrowRight = "<img src='"+FULLROOTPATH+"/static/runright.gif'/>";
    var page       = "1/1";
    
    // Up arrow
    if (r._hasParent)
      headerHTML += "<td><a href='#' "
        + "onclick='return GUI.Plugin.DQMHeaderRow.runNrClick("
        + kw.substring(0, kw.length-1) + ")'>"
        + "<img src='"+FULLROOTPATH+"/static/runup.gif'/></a><td>";

    // L and R arrow
    var nIdx = 0;
    for (i in idx) nIdx++;
    if (r._isFirstPage)
    {
      if (nIdx > r._maxHeaderCols)
      {
        arrowRight =
          "<a href='#' onclick='return GUI.Plugin.DQMHeaderRow.runNrNextPage()'>"
          + arrowRight + "</a>";
        page = "1/2";
      }
    }
    else
    {
      arrowLeft =
        "<a href='#' onclick='return GUI.Plugin.DQMHeaderRow.runNrNextPage()'>"
        + arrowLeft + "</a>";
      page = "2/2";
    }
    msg += arrowLeft + "<span style='font-weight: 800; font-size: 120%'>"
      + page + "</span>" + arrowRight;
    
    // partially matched runNr drawing
    var maxElements, iBody;
    var toskip = (r._isFirstPage) ? 0 : r._maxHeaderCols;
    var toshow = r._maxHeaderCols;
    for (var ch = '9'; ch >= '0'; --ch)
    {
      if (idx[ch])
      {
        if ( toskip-- > 0 ) continue;
        if ( toshow-- == 0 ) break;
        
        var len = idx[ch].length;
        if (len > 1) headerHTML +=
          "<td onMouseOver='GUI.Plugin.DQMHeaderRow.runNrHighLight(" + ch + ", true)'"
          + " onMouseOut='GUI.Plugin.DQMHeaderRow.runNrHighLight(" + ch + ", false)'"
          + " style='font-weight: 800; background-color: #eeeeff; width: 7em'>"
          + "<a href='#' "
          + "onClick='return GUI.Plugin.DQMHeaderRow.runNrClick("+kw+ch+")'>"
          + kw + ch + "...</a> "
          + "<span style='font-size: 80%'>(" + len + ")</span></td>";
        
        iBody = "<tr><td colspan='" + r._maxBodyCols + "' "
          + "style='border-bottom: 2px solid #ffddcc; height: 4px;'></td></tr>";
        maxElements = (len > r._maxIBodyRuns) ? (r._maxIBodyRuns - 3) : len;
        for (var i = 0; i < maxElements; ++i)
        {
          iBody += "<td><a href='#' "
            + "onclick='return GUI.Plugin.DQMHeaderRow.setRun(" + idx[ch][i] + ")'>"
            + "<span name='runset" + ch + "'>" + kw + ch + "</span>"
            + idx[ch][i].substring(kw.length+1) + "</a></td>";
        
          if (i%10 == 9 && maxElements > 10)
            iBody += "</tr><tr>";
        }
        if (len > r._maxIBodyRuns)
          iBody +=
            "<td colspan='"+3+"' style='font-size: 80%; color: #cccccc'>"
            + (len - (r._maxIBodyRuns - 3)) + " more...</td>";
        
        bodyHTML += "<tr>" + iBody + "</tr>";
      }
    }
    bodyHTML =
      "<tr><td colspan='"+r._maxHeaderCols+"'>"
      +"<a href='#' onclick='return GUI.Plugin.DQMHeaderRow.setRun(\"Live\")'>"
      +"Live</a></td></tr>" + bodyHTML;
    r._info.innerHTML   = msg;
    r._header.innerHTML = "<table><tr>" + headerHTML + "</tr></table>";
    r._body.innerHTML   = "<table>" + bodyHTML + "</table>";
  }
  return this;
}();

//////////////////////////////////////////////////////////////////////
// Core objects: selector.
GUI.Plugin.DQMList = new function()
{
  var _SIZES		 = [ "XS", "S", "M", "L", "XL" ];
  var _gui               = null;
  var _selector          = this;
  var _menuObjs          = null;
  var _menuObjSize	 = null;
  var _menuObjsDataset   = null;
  var _menuObjsStep      = null;
  var _menuObjsFilter    = null;
  var _menuObjsQuick     = null;
  var _menuObjsData      = null;
  var _menuObjsSearch    = null;
  var _menuObjsSearchRes = null;
  var _sidebar           = document.getElementById('sidebar');
  var _canvas            = document.getElementById('canvas');
  var _click		 = { event: null, timeout: null, timeClick: 0, timeDoubleClick: 0 };
  var _searchDelay;
  var _searchString;

  this.attach = function(gui)
  {
    _gui = gui;
    _sidebar.style.display = '';
    _canvas.style.left = '15.7em';

    _menuObjs = _gui.buildLeftSide('m-objects', 'Objects').childNodes[1];
    _menuObjs.innerHTML = 
      "<table width='100%'><thead"
      + "><tr><td>Dataset</td><td>"
        + "<select style='font-size:100%' id='m-list-dataset' onchange='GUI.Plugin.DQMList.dataset(this.value)'>"
	+ "</select></td></tr"
      + "><tr><td>Step</td><td>"
        + "<select style='font-size:100%' id='m-list-step' onchange='GUI.Plugin.DQMList.step(this.value)'>"
	+ "</select></td></tr"
      + "><tr><td>Filter</td><td>"
        + "<select style='font-size:100%' id='m-list-filter' onchange='GUI.Plugin.DQMList.filter(this.value)'>"
	+ "<option value='all'>Show all</option>"
	+ "<option value='alarms'>Show alarms</option>"
	+ "<option value='nonalarms'>Show non-alarms</option>"
	+ "</select></td></tr"
      + "><tr><td>Search</td><td><input style='font-size:100%' id='m-list-search' type='text' style='width:90%'/></td></tr"
      + "><tr><td>&nbsp;</td><td id='m-list-searchres'>&nbsp;</td></tr"
      + "></thead><tbody id='m-list-quick'/><tbody id='m-list-data'/></table>";

    _menuObjsQuick = document.getElementById('m-list-quick');
    _menuObjsData = document.getElementById('m-list-data');
    _menuObjsDataset = document.getElementById('m-list-dataset');
    _menuObjsStep = document.getElementById('m-list-step');
    _menuObjsFilter = document.getElementById('m-list-filter');
    _menuObjsSearch = document.getElementById('m-list-search');
    _menuObjsSearchRes = document.getElementById('m-list-searchres');
    _menuObjsSearch.onblur = function(e) {
      clearInterval(_searchDelay);
      _searchDelay = null;
      _selector.searchBackground();
    }
    _menuObjsSearch.onfocus = function(e) {
      clearInterval(_searchDelay);
      _searchDelay = setInterval(_selector.searchBackground, 1000);
    }
  }

  this.detach = function()
  {
    var menutop = _menuObjs.parentNode.parentNode;
    menutop.removeChild(_menuObjs.parentNode);
    _sidebar.style.display = 'none'
    _canvas.style.left = '0em';
  }

  this.dataset = function(choice)
  {
    _gui.makeCall(_url() + "/setDataset?n=" + encodeURIComponent(choice));
    return false;
  }

  this.step = function(choice)
  {
    _gui.makeCall(_url() + "/setStep?n=" + encodeURIComponent(choice));
    return false;
  }

  this.filter = function(choice)
  {
    _gui.makeCall(_url() + "/setFilter?n=" + encodeURIComponent(choice));
    return false;
  }

  this.searchBackground = function()
  {
    if (_searchString != _menuObjsSearch.value)
      _selector.search();
  }

  this.search = function()
  {
    _gui.makeCall(_url() + "/setSearch?rx=" + encodeURIComponent(_menuObjsSearch.value));
    _menuObjsSearchRes.innerHTML = "(searching)";
    _searchString = _menuObjsSearch.value;
  }

  this.rebase = function(name)
  {
    _gui.makeCall(_url() + "/setRoot?n=" + encodeURIComponent(name));
    return false;
  }

  this.onRowSelect = function(e)
  {
    var cell = (e.srcElement || e.target);
    while (cell.tagName != 'TD')
      if (cell.tagName == 'A' && cell.getAttribute('dqmto') != null)
	return _selector.rebase(cell.getAttribute('dqmto'));
      else
        cell = cell.parentNode;

    var row = cell.parentNode;
    var dqmname = row.getAttribute('dqmname');
    for (var r = row.parentNode.firstChild; r; r = r.nextSibling)
      _setclass(r.firstChild,
		r.firstChild.className.replace(/ MEispicked/, '')
		+ ((r == row) ? " MEispicked" : ""));
    _gui.makeCall(_url() + "/setPicked?n=" + encodeURIComponent(dqmname));
    return false;
  }

  this.onRowFocus = function(e)
  {
    var cell = (e.srcElement || e.target);
    while (cell.tagName != 'TD')
      if (cell.tagName == 'A')
	return false;
      else
	cell = cell.parentNode;

    var row = cell.parentNode;
    var dqmname = row.getAttribute('dqmname');
    if (cell.className.indexOf("MEisdir") >= 0)
    {
      if (cell.innerHTML.indexOf("Quick collection") >= 0)
        _selector.onRowSelect(e);
      else
        _selector.rebase(dqmname);
    }
    else
      _gui.makeCall(_url() + "/setFocus?n=" + encodeURIComponent(dqmname));

    return false;
  }

  this.updateTreeRow = function(obj, depth, x, dotop)
  {
    if (! x.row)
    {
      x.row = document.createElement("tr");
      x.row.appendChild(document.createElement("td"));
      x.row.firstChild.colSpan = 2;
      x.root.appendChild (x.row);
      x.row.className = "MErow";
      x.row.ondblclick = x.row.onclick = function(e) {
	return _dblclick(e || window.event, _click, _selector.onRowSelect, _selector.onRowFocus); };
    }

    if (x.row.getAttribute('dqmname') != obj.name)
      x.row.setAttribute('dqmname', obj.name);

    var hasalarm = x.row.className.indexOf("MEisalarm");
    if (obj.nalarm > 0 && hasalarm < 0)
      x.row.className += " MEisalarm";
    else if (! obj.nalarm && hasalarm >= 0)
      x.row.className = x.row.className.replace(/ MEisalarm/, "");

    var name = "";
    if (depth == 0 && dotop)
    {
      name = "<a href='#' onclick='return false' dqmto=''>(Top)</a> ";
      if (obj.name != "")
      {
	var from = 0;
	while (from < obj.name.length)
	{
	  var to = obj.name.indexOf("/", from);
	  if (to == -1) to = obj.name.length;

	  name += " / ";
	  if (to < obj.name.length || obj.isdir)
	    name += "<a href='#' onclick='return false' dqmto='"
		    + obj.name.substr(0, to) + "'>"
		    + obj.name.substr(from, to-from)
		    + "</a>";
	  else
	    name += obj.name.substr(from, to-from);

	  from = to+1;
	}
      }
    }
    else if (depth == 0 && !dotop && obj.isdir)
      name = obj.name;
    else
      name = obj.name.replace(/.*\//, "");

    _setvaltitle(x.row.firstChild,
      "ME" + (obj.nlive ? "" : " MEdead")
	   + (obj.isdir ? " MEisdir" : "")
	   + (obj.isdir && depth < 2 ? " MEisopen" : "")
	   + (obj.ispicked ? " MEispicked" : ""),
      "<span style='margin-left: " + depth + "em'>"
      + "<span style='display:-moz-inline-box;display:inline-block;width:1em'>"
      + (obj.isdir ? (depth < 2 ? "-" : "+") : "&nbsp;")
      + "</span>"
      + name
      + "</span>",
      obj.name + ", " + (obj.isdir ? obj.nleaves + " objects, " : "")
      + (obj.nalarm > 1 ? obj.nalarm + " alarms"
	 : obj.nalarm ? (obj.isdir ? "1 alarm" : "has alarm")
	 : (obj.isdir ? "no alarms" : "no alarm")));

    x.nrow++;
    x.row = x.row.nextSibling;
    for (var i = 0, e = obj.kids.length; i < e; ++i)
      this.updateTreeRow(obj.kids[i], depth+1, x, dotop);
  }

  this.updateSelect = function(sel, data, call)
  {
    var opt = sel.firstChild;
    var selectedIndex = -1;
    for (var i = 0, e = data.length; i < e; ++i)
    {
      if (! opt)
	sel.appendChild (opt = document.createElement("option"));

      if (opt.innerHTML != data[i].name)
      {
	opt.innerHTML = data[i].name;
	opt.value = data[i].name;
      }

      if (data[i].selected)
	selectedIndex = i;

      opt = opt.nextSibling;
    }

    while (opt)
    {
      var node = opt;
      opt = opt.nextSibling;
      sel.removeChild(node);
    }

    if (selectedIndex == -1 && data.length > 0)
    {
      _gui.makeCall(_url() + call + encodeURIComponent(data[0].name))
      selectedIndex = 0;
    }

    if (sel.selectedIndex != selectedIndex)
      sel.selectedIndex = selectedIndex;
  }

  this.update = function(data)
  {
    // Update the object tree.
    var x = { root: _menuObjsQuick, row: _menuObjsQuick.firstChild, nrow: 0 };
    this.updateTreeRow(data.quick, 0, x, false);
    while (x.row)
    {
      var node = x.row;
      x.row = node.nextSibling;
      x.root.removeChild(node);
    }

    x = { root: _menuObjsData, row: _menuObjsData.firstChild, nrow: 0 };
    this.updateTreeRow(data.tree, 0, x, true);
    while (x.row)
    {
      var node = x.row;
      x.row = node.nextSibling;
      x.root.removeChild(node);
    }

    // Update the search info.
    var search = data.def.search;
    var word = (search.pattern == '' ? " object" : " match");
    var plural = (search.pattern == '' ? "s" : "es");
    var searchres = (! search.valid ? "(invalid regexp)"
		     : (search.nmatches > 1 ? "(" + search.nmatches + word + plural + ")"
		        : search.nmatches == 1 ? "(1 " + word + ")"
		        : "(no " + word + plural + ")"));
    if (! _searchDelay && _menuObjsSearch.value != search.pattern)
      _menuObjsSearch.value = search.pattern;
    if (_menuObjsSearchRes.innerHTML != searchres)
      _menuObjsSearchRes.innerHTML = searchres;

    // Update the selectors.
    this.updateSelect(_menuObjsDataset, data.def.dataset, "/setDataset?n=");
    this.updateSelect(_menuObjsStep, data.def.step, "/setStep?n=");
    for (var i = _menuObjsFilter.firstChild, n = 0; i; i = i.nextSibling, ++n)
      if (i.value == data.def.filter)
      {
	_menuObjsFilter.selectedIndex = n;
	break;
      }
  }

  return this;
}();

//////////////////////////////////////////////////////////////////////
// Core objects: canvas.
GUI.Plugin.DQMCanvas = new function()
{
  var _SLIDER_UNIT	   = 20;
  var _IMG_BORDER_NONE     = "1px solid transparent";
  var _IMG_BORDER_NEW      = "1px solid #4a4";
  var _IMG_BORDER_ALARM    = "1px solid #a33";
  var _SIZES = [ { index: 0, label: "XS", className: "size-xsmall", width: 67,  height: 50 },
		 { index: 1, label: "S",  className: "size-small",  width: 133, height: 100 },
		 { index: 2, label: "M",  className: "size-medium", width: 266, height: 200 },
		 { index: 3, label: "L",  className: "size-large",  width: 532, height: 400 },
		 { index: 4, label: "XL", className: "size-xlarge", width: -1,  height: -1 } ];
  var _SIZEMAP = {}; _map(_SIZES, function(x) { _SIZEMAP[x.label] = x });
  var _AXES = { "lin": 0, "log": 1 };

  var _perpage		= 12;
  var _picked		= null;
  var _size		= "M";

  var _gui		= null;
  var _canvas		= this;
  var _gcanvas		= document.getElementById('canvas-area');
  var _optsarea		= document.getElementById('canvas-opts');
  var _menuarea		= document.getElementById('canvas-menu');
  var _playarea		= document.getElementById('canvas-play');
  var _playlist		= document.getElementById('canvas-play-list');
  var _helparea		= document.getElementById('canvas-help');

  var _szthumb		= null;
  var _szslider		= null;
  var _optPerPage	= null;
  var _optPlayMode	= null;
  var _optPlayInterval	= null;

  var _imgXType		= null;
  var _imgXMin		= null;
  var _imgXMax		= null;
  var _imgYType		= null;
  var _imgYMin		= null;
  var _imgYMax		= null;
  var _imgZType		= null;
  var _imgZMin		= null;
  var _imgZMax		= null;
  var _imgDrawOpts	= null;
  var _imgWithRef	= null;

  var _shown		= null;
  var _playInterval	= null;
  var _playinfo		= { on: 0, interval: 5, pos: 0, page: 0, max: 0 };
  var _click		= { event: null, timeout: null, timeClick: 0, timeDoubleClick: 0 };

  this.onresize = function()
  {
    var h = (_optsarea.style.display == '' ? _optsarea.clientHeight : _menuarea.clientHeight);
    var top = _gcanvas.offsetTop;
    var newtop = h+2;
    if (top != newtop)
      _gcanvas.style.top = newtop + 'px';

    var size = _SIZEMAP["XL"];
    for (var i = 0, obj = _gcanvas.firstChild; obj; ++i, obj = obj.nextSibling)
      if (obj.className.indexOf("size-xlarge") >= 0)
      {
        var nrows = obj.childNodes.length-1;
        for (var row = 0; row < nrows; ++row)
        {
	  var ncols = obj.childNodes[row+1].childNodes.length;
	  for (var col = 0; col < ncols; ++col)
	  {
	    var img = obj.childNodes[row+1].childNodes[col];
	    var suffix = this.setsize(img, size, row, nrows, col, ncols);
	    var url = img.src.replace(/;w=.*/, suffix);
	    if (img.src != url)
	    {
	      img.dqmsrc = url;
	      GUI.ImgLoader.load("div"+i+"."+row+"."+col, img, url);
	    }
	  }
        }
      }
  }

  this.describe = function(e)
  {
    e = e || window.event;
    var hit = (e.srcElement || e.target);
    if (hit.tagName == 'IMG' && hit.getAttribute('dqmhelp'))
      _helparea.innerHTML = "<div>" + hit.getAttribute('dqmhelp') + "</div>";
    else if (hit.tagName == 'IMG' && hit.title)
      _helparea.innerHTML = "<span style='color:#888'>(No description available for "
			    + hit.title + ".)</span>";
    else
      _helparea.innerHTML = "";
  }

  this.attach = function(gui)
  {
    _gui = gui;
    _gcanvas.style.bottom = '4em';
    if (! _optsarea.firstChild)
    {
      var div, item;
      _optsarea.appendChild(div = document.createElement('div'));
      div.className = 'group';

      div.appendChild(item = document.createElement('div'));
      item.style.cssFloat = 'left';
      item.style.styleFloat = 'left';
      item.style.marginRight = '6px';
      item.innerHTML = 'Small';

      div.appendChild(item = document.createElement('div'));
      item.id = 'canvas-size-slider';
      item.style.cssFloat = 'left';
      item.style.styleFloat = 'left';
      item.appendChild(item = document.createElement('div'));
      item.id = 'canvas-size-thumb';
      item.appendChild(item = document.createElement('img'));
      item.src = FULLROOTPATH + "/static/down.gif";
      item.width = "10";
      item.height = "10";

      div.appendChild(item = document.createElement('div'));
      item.style.cssFloat = 'left';
      item.style.styleFloat = 'left';
      item.style.marginLeft = '6px';
      item.style.marginRight = '6px';
      item.innerHTML = "Large";

      div.appendChild(item = document.createElement('div'));
      item.style.cssFloat = 'left';
      item.style.styleFloat = 'left';
      item.innerHTML = "<input style='font-size:100%' type='text' size='2'/> per page";
      _optPerPage = item.firstChild;
      _optPerPage.value = _perpage;
      _optPerPage.onchange = function() { _canvas.perpage(this.value); }

      _optsarea.appendChild(div = document.createElement('div'));
      div.className = 'group';

      div.appendChild(item = document.createElement('div'));
      item.style.cssFloat = 'left';
      item.style.styleFloat = 'left';
      item.innerHTML = "<a href='#'>Play</a><span>; rate </span><input style='font-size:100%' type='text' size='3' /><span> sec</span>";
      _optPlayMode = item.firstChild;
      _optPlayInterval = item.childNodes[2];
      _optPlayInterval.value = _playinfo.interval;
      _optPlayMode.onclick = function() { _canvas.play(); return false; }
      _optPlayInterval.onchange = function() { _canvas.playInterval(this.value); }

      _optsarea.appendChild(div = document.createElement('div'));
      div.className = 'group';

      div.appendChild(item = document.createElement('div'));
      item.style.cssFloat = 'left';
      item.style.styleFloat = 'left';
      item.innerHTML = "<a href='#'>Reset workspace</a>";
      item.firstChild.onclick = function() { _gui.makeCall(_url() + "/resetWorkspace"); return false; }
    }

    if (! _menuarea.firstChild)
    {
      _menuarea.innerHTML =
        "<div class='group'>X:"
        + " <select style='font-size:100%' id='m-obj-x-type'>"
        + "<option value='lin'>Linear</option>"
        + "<option value='log'>Log</option>"
        + "</select>"
        + " Range: <input style='font-size:100%' id='m-obj-x-min' size='4' type='text' />"
        + " ... <input style='font-size:100%' id='m-obj-x-max' size='4' type='text' /></div>"
        + "<div class='group'>Y:"
        + " <select style='font-size:100%' id='m-obj-y-type'>"
        + "<option value='lin'>Linear</option>"
        + "<option value='log'>Log</option>"
        + "</select>"
        + " Range: <input style='font-size:100%' id='m-obj-y-min' size='4' type='text' />"
        + " ... <input style='font-size:100%' id='m-obj-y-max' size='4' type='text' /></div>"

        + "<div class='group'>Z:"
        + " <select style='font-size:100%' id='m-obj-z-type'>"
        + "<option value='lin'>Linear</option>"
        + "<option value='log'>Log</option>"
        + "</select>"
        + " Range: <input style='font-size:100%' id='m-obj-z-min' size='4' type='text' />"
        + " ... <input style='font-size:100%' id='m-obj-z-max' size='4' type='text' /></div>"

        + "<div class='group'>Draw options: <input style='font-size:100%' id='m-obj-draw-opts' size='4' type='text' /></div>"

        + "<div class='group'>Reference: <input style='font-size:100%' id='m-obj-with-ref' type='checkbox' /></div>";

      _imgXType    = document.getElementById('m-obj-x-type');
      _imgXMin     = document.getElementById('m-obj-x-min');
      _imgXMax     = document.getElementById('m-obj-x-max');
      _imgYType    = document.getElementById('m-obj-y-type');
      _imgYMin     = document.getElementById('m-obj-y-min');
      _imgYMax     = document.getElementById('m-obj-y-max');
      _imgZType    = document.getElementById('m-obj-z-type');
      _imgZMin     = document.getElementById('m-obj-z-min');
      _imgZMax     = document.getElementById('m-obj-z-min');
      _imgDrawOpts = document.getElementById('m-obj-draw-opts');
      _imgWithRef  = document.getElementById('m-obj-with-ref');

      _imgXType.onchange    = function() { _canvas.alterImage("xtype",    this.value); return false; }
      _imgXMin.onchange     = function() { _canvas.alterImage("xmin",     this.value); return false; }
      _imgXMax.onchange     = function() { _canvas.alterImage("xmax",     this.value); return false; }
      _imgYType.onchange    = function() { _canvas.alterImage("ytype",    this.value); return false; }
      _imgYMin.onchange     = function() { _canvas.alterImage("ymin",     this.value); return false; }
      _imgYMax.onchange     = function() { _canvas.alterImage("ymax",     this.value); return false; }
      _imgZType.onchange    = function() { _canvas.alterImage("ztype",    this.value); return false; }
      _imgZMin.onchange     = function() { _canvas.alterImage("zmin",     this.value); return false; }
      _imgZMax.onchange     = function() { _canvas.alterImage("zmax",     this.value); return false; }
      _imgDrawOpts.onchange = function() { _canvas.alterImage("drawopts", this.value); return false; }
      _imgWithRef.onchange  = function() { _canvas.alterImage("withref",  this.checked ? "yes" : "no"); return false; }
    }

    if (! _szslider)
    {
      _szslider = document.getElementById("canvas-size-slider");
      _szthumb = document.getElementById("canvas-size-thumb");
      _szslider.onclick = function(e) { return _canvas.onSizeMove(e || window.event); };
    }

    this.setSizeSlider();

    // Install a click handler on canvas to deselect everything.
    // We want this to fire only if the click was actually on
    // the canvas itself, not on one of the items it contains.
    _gcanvas.onclick = _gcanvas.ondblclick = function(e) {
      return _dblclick(e || window.event, _click, _canvas.onPick, _canvas.onFocus); };
  }

  this.setSizeSlider = function() 
  {
    _szthumb.style.marginLeft = (_SIZEMAP[_size].index * _SLIDER_UNIT - 1) + "px";
  }

  this.detach = function()
  {
    if (_playInterval)
    {
      clearInterval(_playInterval);
      _playInterval = null;
    }

    _optsarea.style.display = 'none';
    _menuarea.style.display = 'none';
    _playarea.style.display = 'none';
    _helparea.style.display = 'none';
    _gcanvas.style.bottom = '0';
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
    _gcanvas.onclick = null;
  }

  this.onSizeMove = function(e)
  {
    if ((e.srcElement || e.target) != _szslider)
      return false;

    var pos = YAHOO.util.Dom.getXY(_szslider);
    var x = ((e.x != undefined && e.x != e.clientX)
	     ? e.x : (e.clientX - pos[0] - 12));
    if (isNaN(x))
      x = 2 * _SLIDER_UNIT;

    var index = Math.round(x / _SLIDER_UNIT);
    if (index < 0)
      index = 0;
    if (index > 4)
      index = 4;

    _szthumb.style.marginLeft = (index * _SLIDER_UNIT - 1) + "px";

    var size = _SIZES[index];
    if (_size != size.label)
    {
      _size = size.label; 
      _canvas.resize();
      _gui.makeCall(_url() + "/setSize?sz=" + size.label);
    }

    return false;
  }

  this.onPick = function(e)
  {
    var hit = (e.srcElement || e.target);
    if (hit == _gcanvas)
      _gui.makeCall(_url() + "/setPicked");
    else
    {
      while (hit.tagName != 'DIV' && hit.className.indexOf("item") >= 0)
	hit = hit.parentNode;
      _gui.makeCall(_url() + "/setPicked?n=" + encodeURIComponent(hit.title));
    }
    return false;
  }

  this.onFocus = function(e)
  {
    var hit = (e.srcElement || e.target);
    if (hit != _gcanvas)
    {
      while (hit.tagName != 'DIV' && hit.className.indexOf("item") >= 0)
	hit = hit.parentNode;
      if (hit && hit.title && _menuarea.style.display == 'none')
	_gui.makeCall(_url() + "/setFocus?n=" + encodeURIComponent(hit.title));
      else
	_gui.makeCall(_url() + "/setFocus");
    }
    return false;
  }

  this.updateOptions = function(params)
  {
    if (! params.focus)
    {
      if (_menuarea.style.display != 'none')
        _menuarea.style.display = 'none';

      if (_optsarea.style.display != '')
        _optsarea.style.display = '';

      _playinfo = params.play;

      if (_optPerPage.value != _perpage)
        _optPerPage.value = _perpage;

      var playmode = (_playinfo.on ? "Stop" : "Play");
      if (_optPlayMode.innerHTML != playmode)
        _optPlayMode.innerHTML = playmode;

      if (_optPlayInterval.value != _playinfo.interval)
        _optPlayInterval.value = _playinfo.interval;

      if (_playInterval)
      {
        clearInterval(_playInterval);
	_playInterval = null;
      }

      if (_playinfo.on)
      {
        _playInterval = setInterval(this.playStep, _playinfo.interval*1000);
	for (var i = 0; i < 3; ++i)
	  _optsarea.firstChild.childNodes[i].style.display = 'none';
      }
      else
      {
	for (var i = 0; i < 3; ++i)
	  _optsarea.firstChild.childNodes[i].style.display = '';
      }

      this.setSizeSlider();
    }
    else
    {
      if (_optsarea.style.display != 'none')
        _optsarea.style.display = 'none';
      if (_menuarea.style.display != '')
        _menuarea.style.display = '';

      var obj   = _gcanvas.firstChild;
      var opts  = null, ref  = null;
      var xtype = null, xmin = null, xmax = null;
      var ytype = null, ymin = null, ymax = null;
      var ztype = null, zmin = null, zmax = null;
      var nrows = obj.childNodes.length-1;
      for (var row = 0; row < nrows; ++row)
      {
	var ncols = obj.childNodes[row+1].childNodes.length;
	for (var col = 0; col < ncols; ++col)
	{
	  var img	= obj.childNodes[row+1].childNodes[col];
	  var url       = img.dqmsrc;
	  var iopts     = url.indexOf("drawopts=") >= 0 ? url.replace(/.*drawopts=([^;]*).*/, "$1") : "";
	  var iref      = url.indexOf("withref=") >= 0  ? url.replace(/.*withref=([^;]*).*/, "$1")  : "";
	  var ixtype    = url.indexOf("xtype=") >= 0    ? url.replace(/.*xtype=([^;]*).*/, "$1")    : "";
	  var ixmin     = url.indexOf("xmin=") >= 0     ? url.replace(/.*xmin=([^;]+).*/, "$1")     : "";
	  var ixmax     = url.indexOf("xmax=") >= 0     ? url.replace(/.*xmax=([^;]+).*/, "$1")     : "";
	  var iytype    = url.indexOf("ytype=") >= 0    ? url.replace(/.*ytype=([^;]*).*/, "$1")    : "";
	  var iymin     = url.indexOf("ymin=") >= 0     ? url.replace(/.*ymin=([^;]+).*/, "$1")     : "";
	  var iymax     = url.indexOf("ymax=") >= 0     ? url.replace(/.*ymax=([^;]+).*/, "$1")     : "";
	  var iztype    = url.indexOf("ztype=") >= 0    ? url.replace(/.*ztype=([^;]*).*/, "$1")    : "";
	  var izmin     = url.indexOf("zmin=") >= 0     ? url.replace(/.*zmin=([^;]+).*/, "$1")     : "";
	  var izmax     = url.indexOf("zmax=") >= 0     ? url.replace(/.*zmax=([^;]+).*/, "$1")     : "";

	  if (opts  == null) opts  = iopts;  else if (opts  != iopts)  opts  = "";
	  if (ref   == null) ref   = iref;   else if (ref   != iref)   ref   = "";
	  if (xtype == null) xtype = ixtype; else if (xtype != ixtype) xtype = "";
	  if (xmin  == null) xmin  = ixmin;  else if (xmin  != ixmin)  xmin  = "";
	  if (xmax  == null) xmax  = ixmax;  else if (xmax  != ixmax)  xmax  = "";
	  if (ytype == null) ytype = iytype; else if (ytype != iytype) ytype = "";
	  if (ymin  == null) ymin  = iymin;  else if (ymin  != iymin)  ymin  = "";
	  if (ymax  == null) ymax  = iymax;  else if (ymax  != iymax)  ymax  = "";
	  if (ztype == null) ztype = iztype; else if (ztype != iztype) ztype = "";
	  if (zmin  == null) zmin  = izmin;  else if (zmin  != izmin)  zmin  = "";
	  if (zmax  == null) zmax  = izmax;  else if (zmax  != izmax)  zmax  = "";
	}
      }

      if (opts  == null) opts  = "";
      if (ref   == null) ref   = "";
      if (xtype == null) xtype = "";
      if (xmin  == null) xmin  = "";
      if (xmax  == null) xmax  = "";
      if (ytype == null) ytype = "";
      if (ymin  == null) ymin  = "";
      if (ymax  == null) ymax  = "";
      if (ztype == null) ztype = "";
      if (zmin  == null) zmin  = "";
      if (zmax  == null) zmax  = "";

      if (ref == "yes")
        ref = "checked";
      else if (ref == "no")
        ref = "";

      if (_imgDrawOpts.value != opts)
        _imgDrawOpts.value = opts;

      if (_imgWithRef.checked != ref)
        _imgWithRef.value = ref;

      if (_imgXType.selectedIndex != _AXES[xtype])
        _imgXType.selectedIndex = _AXES[xtype];
      if (_imgXMin.value != xmin)
        _imgXMin.value = xmin;
      if (_imgXMax.value != xmax)
        _imgXMax.value = xmax;

      if (_imgYType.selectedIndex != _AXES[ytype])
        _imgYType.selectedIndex = _AXES[ytype];
      if (_imgYMin.value != ymin)
        _imgYMin.value = ymin;
      if (_imgYMax.value != ymax)
        _imgYMax.value = ymax;

      if (_imgZType.selectedIndex != _AXES[ztype])
        _imgZType.selectedIndex = _AXES[ztype];
      if (_imgZMin.value != zmin)
        _imgZMin.value = zmin;
      if (_imgZMax.value != zmax)
        _imgZMax.value = zmax;
    }
  }

  this.alterImage = function(param, value)
  {
    _gui.makeCall(_url() + "/alterImage?"
		  + "o=" + encodeURIComponent(_gcanvas.firstChild.title)
		  + ";opt=" + encodeURIComponent(param)
		  + ";value=" + encodeURIComponent(value));
    return false;
  }

  this.play = function()
  {
    if (_playInterval)
    {
      clearInterval(_playInterval);
      _playInterval = null;
    }

    if (_playinfo.on)
      _gui.makeCall(_url() + "/setPlayMode?mode=no");
    else
      _gui.makeCall(_url() + "/setPlayMode?mode=yes");
  }

  this.playInterval = function(value)
  {
    var newval = parseInt(value);
    if (isNaN(newval))
      newval = 5;
    else if (newval < 2)
      newval = 2;
    else if (newval > 99)
      newval = 99;

    if (newval != _playinfo.interval)
    {
      _playinfo.interval = newval;
      if (_optPlayInterval.value != newval)
        _optPlayInterval.value = newval;
      _gui.makeCall(_url() + "/setPlayInterval?v=" + newval);
    }
  }

  this.playStep = function()
  {
    if (! _playinfo.on)
      return;

    var curpos = _playinfo.pos - _playinfo.page*_perpage;
    if (curpos < _playlist.childNodes.length)
    {
      var curnode = _playlist.childNodes[curpos];
      _setclass(curnode, curnode.className.replace(/ playhead/, ""));
    }

    if (++_playinfo.pos >= _playinfo.max)
    {
      clearInterval(_playInterval);
      _playInterval = null;
      _playinfo.pos = 0;
      if (_playinfo.max)
      {
        _gui.makeCall(_url() + "/movePlayPosition?n=" + _playinfo.pos + ";move=yes");
        return;
      }
    }

    if (_shown.length)
    {
      curpos = _playinfo.pos - _playinfo.page*_perpage;
      if (curpos >= _shown.length && _shown.length)
      {
        clearInterval(_playInterval);
        _playInterval = null;
        _gui.makeCall(_url() + "/movePlayPosition?n=" + _playinfo.pos + ";move=yes");
      }
      else
      {
        curnode = _playlist.childNodes[curpos];
        _setclass(curnode, curnode.className + " playhead");

        _canvas.layout("div", _gcanvas, _gcanvas.firstChild, _shown[curpos], "XL", "", "div0")
        YAHOO.util.Connect.asyncRequest("GET", _url() + "/movePlayPosition?n=" + _playinfo.pos);
      }
    }
  }

  this.perpage = function(value)
  {
    var newval = parseInt(value);
    if (isNaN(newval))
      newval = 12;
    else if (newval < 1)
      newval = 1;
    else if (newval > 99)
      newval = 99;

    if (newval != _perpage)
    {
      if (_optPerPage.value != newval)
        _optPerPage.value = newval;
      _gui.makeCall(_url() + "/setPerPage?n=" + newval);
    }
  }

  this.pick = function(name)
  {
    _gui.makeCall(_url() + "/setPicked?n=" + encodeURIComponent(name));
    return false;
  }

  this.resize = function()
  {
    var size = _SIZEMAP[_size];
    for (var i = 0; i < _gcanvas.childNodes.length; ++i)
    {
      var obj = _gcanvas.childNodes[i];
      var title = obj.childNodes[0];
      var titlew = size.width + "px";
      if (size.width > 0 && title.style.width != titlew)
	title.style.width = titlew;
      else if (size < 0 && title.style.width != '')
	title.style.width = '';

      var nrows = obj.childNodes.length-1;
      for (var row = 0; row < nrows; ++row)
      {
	var ncols = obj.childNodes[row+1].childNodes.length;
	for (var col = 0; col < ncols; ++col)
	{
	  var img = obj.childNodes[row+1].childNodes[col];
	  var suffix = this.setsize(img, size, row, nrows, col, ncols);
	  var url = img.src.replace(/;w=.*/, suffix);
	  if (img.src != url)
	  {
	    img.dqmsrc = url;
	    GUI.ImgLoader.load("div"+i+"."+row+"."+col, img, url);
	  }
	}
      }

      var newClass = obj.className.replace(/size-[a-z]+/, size.className);
      if (obj.className != newClass)
	obj.className = newClass;
    }
  }

  this.setsize = function(img, size, row, rows, col, cols)
  {
    var maxwidth = _gcanvas.clientWidth - 50;
    var maxheight = _gcanvas.clientHeight - 70;
    if (maxwidth/1.33 > maxheight)
      maxwidth = Math.floor(1.33 * maxheight);
    else
      maxheight = Math.floor(maxwidth / 1.33);

    var width = (size.width > 0 ? size.width : maxwidth);
    var height = (size.height > 0 ? size.height : maxheight);
    var w = Math.round((width+2-2*cols)/cols); 
    var h = Math.round((height+2-2*rows)/rows);
    if (col == cols-1)
      w += (width+2) - (w+2)*cols;
    if (row == rows-1)
      h += (height+2) - (h+2)*rows;
    if (img.width != w)
      img.width = w;
    if (img.height != h)
      img.height = h;
    return ";w=" + w + ";h=" + h;
  }

  // Layout one canvas item.
  this.layout = function(type, container, item, obj, sz, xstyle, n)
  {
    var title;

    // Insert new object if one didn't exist previously.
    if (! item)
    {
      item = document.createElement(type);
      title = document.createElement("h3");
      item.appendChild(title);
      container.appendChild(item);
    }

    // Otherwise overwrite the existing one.
    else
    {
      title = item.firstChild;
    }

    // Now update the item.
    var alarm = 0;
    var picked = (_picked == obj.name);
    var dead = 0;
    for (var row = 0, nrows = obj.items.length; row < nrows; ++row)
      for (var col = 0, ncols = obj.items[row].length; col < ncols; ++col)
      {
	var ob = obj.items[row][col];
	alarm += ob.alarm;
	dead += ! ob.live;
      }

    var style = ("item"
		 + xstyle
		 + (alarm ? " alarm" : "")
		 + (picked ? " picked" : "")
		 + (dead ? " dead" : ""));
    _settitle(item, style, obj.name);
    _setval(title, "", obj.name.replace(/.*\//, ""));

    // Make sure layout in place conforms to the new structure.
    // Reinitialise and remove only where necessary, and reuse
    // old objects otherwise.  Give the image a URL to the
    // server call that generates the image, but don't touch
    // the URL unnecessarily.
    var size = _SIZEMAP[sz];
    var nrows = obj.items.length;
    for (var row = 0; row < nrows; ++row)
    {
      var rowdiv = (row < item.childNodes.length - 1
		    ? item.childNodes[row+1]
		    : document.createElement("div"));
      var rowparent = rowdiv.parentNode;
      var ncols = obj.items[row].length;

      for (var col = 0; col < ncols; ++col)
      {
	var img = (col < rowdiv.childNodes.length
		   ? rowdiv.childNodes[col]
		   : document.createElement("img"));
	if (! img.parentNode)
	  rowdiv.appendChild(img);
	var ob = obj.items[row][col];
	var sizeparam = this.setsize(img, size, row, nrows, col, ncols);
	var imgref = (! ob.name ? FULLROOTPATH + "/static/blank.gif?"
		      : FULLROOTPATH + "/plotfairy/"
		      + encodeURIComponent(ob.location).replace(/%2F/g, "/") + "/"
		      + encodeURIComponent(ob.name).replace(/%2F/g, "/") + "?");
	var param = "session=" + SESSION_ID
		    + ";v=" + ob.version
		    + ";xtype=" + ob.xaxis.type
		    + (ob.xaxis.min != null ? ";xmin=" + ob.xaxis.min : "")
		    + (ob.xaxis.max != null ? ";xmax=" + ob.xaxis.max : "")
		    + ";ytype=" + ob.yaxis.type
		    + (ob.yaxis.min != null ? ";ymin=" + ob.yaxis.min : "")
		    + (ob.yaxis.max != null ? ";ymax=" + ob.yaxis.max : "")
		    + ";ztype=" + ob.zaxis.type
		    + (ob.zaxis.min != null ? ";zmin=" + ob.zaxis.min : "")
		    + (ob.zaxis.max != null ? ";zmax=" + ob.zaxis.max : "")
		    + ";drawopts=" + ob.drawopts
		    + ";withref=" + ob.withref;
	var url = imgref + param + sizeparam;
	var border = ((ob.alarm && (nrows > 1 || ncols > 1))
		      ? _IMG_BORDER_ALARM : _IMG_BORDER_NONE);

        if (! ob.name && img.src != url)
	  img.src = url;
	else if (img.src != url)
	{
	  img.dqmsrc = url;
	  GUI.ImgLoader.load(n+"."+row+"."+col, img, url, border, _IMG_BORDER_NEW);
	  if (img.src.replace(/\?.*/, "?") != imgref)
	    img.src = FULLROOTPATH + "/static/blank.gif";
	  border = img.style.border;
	}
	if (img.style.border != border)
	  img.style.border = border;

	if (img.title != ob.name)
	  img.title = ob.name;

	if (img.getAttribute('dqmhelp') != ob.desc)
	  img.setAttribute('dqmhelp', ob.desc);

	if (! img.onmouseover)
	  img.onmouseover = this.describe;
      }

      while (rowdiv.childNodes.length > ncols)
	rowdiv.removeChild (rowdiv.lastChild);

      if (rowdiv.className != "row")
	rowdiv.className = "row";

      if (! rowparent)
	item.appendChild(rowdiv);
    }

    while (item.childNodes.length > nrows+1)
      item.removeChild (item.lastChild);

    if (item.className.indexOf("size-") < 0)
      item.className += " " + size.className;
    else
      item.className = item.className.replace(/size-[a-z]+/, size.className);

    var titlew = size.width + "px";
    if (size.width > 0 && title.style.width != titlew)
      title.style.width = titlew;
    else if (size.width < 0 && title.style.width != '')
      title.style.width = '';

    return item;
  }

  this.update = function(data)
  {
    _shown = data.items;
    _perpage = data.params.perpage;
    _picked = data.params.picked;
    _size = data.params.size;

    // Run a loop to handle new contents.  We modify the contents
    // of "_gcanvas" in place in order to avoid unpleasant flicker
    // and changes in scroll position.
    //
    // In the normal mode we fill the canvas with the shown objects.
    // In the play mode we fill the play list with small objects, and
    // the canvas with the currently selected object.
    var item = null;
    var playpos = data.params.play.pos - data.params.play.page * _perpage;
    var type = (data.params.play.on ? "td" : "div");
    var root = (data.params.play.on ? _playlist : _gcanvas);
    var size = (data.params.play.on ? "XS"
		: data.params.focus ? "XL"
		: data.params.size);

    for (var n = 0, item = root.firstChild; n < _shown.length;
	 ++n, item = item.nextSibling)
      item = this.layout(type, root, item, _shown[n], size,
			 n == playpos ? " playhead" : "",
			 type + n);

    // Remove whatever is left of old contents.
    while (item)
    {
      var next = item.nextSibling;
      root.removeChild(item);
      item = next;
    }

    // In play mode, put selected object as if in focus mode.
    if (data.params.play.on)
    {
      if (_playarea.style.display != '')
        _playarea.style.display = '';
      if (_helparea.style.display != 'none')
        _helparea.style.display = 'none';
      if (_gcanvas.style.bottom != '8.2em')
	_gcanvas.style.bottom = '8.2em';
      if (playpos < _shown.length)
      {
        item = this.layout("div", _gcanvas, _gcanvas.firstChild,
			   _shown[playpos], "XL", "", "div0");
	item = item.nextSibling;
      }
      else
        item = _gcanvas.firstChild;

      while (item)
      {
	var next = item.nextSibling;
	_gcanvas.removeChild(item);
	item = next;
      }
    }
    else
    {
      if (_playarea.style.display != 'none')
        _playarea.style.display = 'none';
      if (_helparea.style.display != '')
        _helparea.style.display = '';
      if (_gcanvas.style.bottom != '4em')
	_gcanvas.style.bottom = '4em';
    }

    // Update image options and page selector.
    this.updateOptions(data.params);
    this.onresize();
  }

  return this;
}();


//////////////////////////////////////////////////////////////////////
// Core objects: canvas.
GUI.Plugin.DQMSummary = new function()
{
  var _gui		   = null;
  var _canvas              = this;
  var _gcanvas             = document.getElementById('canvas-area');
  var _qrender		   = "";
  var _qavail		   = [];
  var _qmap		   = {};

  this.attach = function(gui)
  {
    _gui = gui;
    _gcanvas.style.bottom = 0;
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.update = function(data)
  {
    _qrender = data.qrender;
    _qavail = [];
    _qmap = {};

    var status = data.items;
    var now = new Date();
    var content;

    if (! status.length)
    {
      content =
        "<div align='center' style='font-size: 2em; padding: 2em; color: #700'>"
	+ "<p>No new data are available presently.</p></div>";    
    }
    else
    {
      content = 
        "<div style='padding:.25em 2em'><table id='summary-table'"
	+ " cellpadding='2' style='white-space: nowrap; border-collapse: collapse'>"
	+ "<thead><tr bgcolor='#f0f0ff'>"
        + "<th valign='bottom' align='left'>Subsystem</th>"
        + "<th valign='bottom' align='right'>Summary</th>"
        + "<th valign='bottom' align='right'>Run</th>"
        + "<th valign='bottom' align='right'>Lumi<br />section</th>"
        + "<th valign='bottom' align='right'>Event</th>"
        + "<th valign='bottom' align='right'>Last update</th>"
        + "<th valign='bottom' align='right'>Last event</th>"
        + "<th valign='bottom' align='right'>Processed<br />events</th>"
        + "<th valign='bottom' align='right'>Event<br /> rate</th>"
        + "<th valign='bottom' align='right'>Monitor<br />elements</th>"
        // + "<th>CMSSW version</th>"
        // + "<th>DQM patch</th>"
        // + "<th>Host</th>"
        // + "<th>Process ID</th>"
        // + "<th>Working directory</th>"
        + "</tr></thead><tbody>";

      for (var i = 0, e = status.length; i < e; ++i)
      {
        var obj = status[i];
        var color = ((obj.reportSummary == null || obj.reportSummary < 0) ? "#000"
  		     : (obj.reportSummary < 0.85 ? "#a22"
	  		: (obj.reportSummary < 0.95 ? "#c30" : "#272")));
        var bcolor = ((obj.reportSummary == null || obj.reportSummary < 0) ? "#f0f0f0"
  		      : (obj.reportSummary < 0.85 ? "#fff0f0"
		         : (obj.reportSummary < 0.95 ? "#fff0c0" : "#efe")));

        var pts = new Date();
        var ets = new Date();

	// Event time stamp correct from CMSSW_1_7_1, DQMPATCH:04 onwards
        pts.setTime(obj.processTimeStamp*1000);
	ets.setTime((obj.eventTimeStamp & 0xffffffff) * 1000);

	content +=
          "<tr style='background-color:" + bcolor + "; color:" + color
	  + "'><td style='padding-left:3px"
	  + "; font-weight:" + (data.qplot == obj.processName ? "bold" : "normal")
	  + "'><a href='#' onclick='return GUI.Plugin.DQMSummary.qmap(this.textContent, true)'>"
	  + _sanitise(obj.processName) + "</a></td>"
          + "<td align='right'>"
          + (obj.reportSummary >= 0 ? sprintf("%.1f%%", obj.reportSummary*100.)
	     : (obj.reportSummary == -1 ? "No DAQ" : "N/A"))
          + "</td>"
          + "<td align='right'>" + obj.iRun + "</td>"
          + "<td align='right'>" + obj.iLumiSection + "</td>"
          + "<td align='right'>" + obj.iEvent + "</td>"
          + "<td align='right'>"
	  + (obj.processTimeStamp > 0 ? _formatTime(pts, now) : "(Never)") + "</td>"
          + "<td align='right'>" 
	  + (obj.eventTimeStamp > 10000 ? _formatTime(ets, now) : "(Never)") + "</td>"
          + "<td align='right'>" + _sanitise(obj.processedEvents) + "</td>"
          + "<td align='right'>"
	  + (obj.processEventRate != undefined
	     ? Math.round(obj.processEventRate*100.)/100.
	     : "&#8211;") + "</td>"
          + "<td style='padding-right:3px' align='right'>" + obj.MEs + "</td>"
          + "</tr>";

        _qavail.push(obj.processName);
        var q = _qmap[obj.processName] = {};
        for (key in obj)
	  if (key.substr(0, 22) == "reportSummaryContents/")
	    q[key.substring(22)] = obj[key];
        q["zzzstamp"] = obj.processTimeStamp;
      }

      content += "</tbody></table></div><div id='qdetail'></div>";
    }

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (status.length)
      this.qmap(data.qplot, false);
  }

  this.qmap = function(label, reset)
  {
    var qkey = (label ? label : _qavail[0]);
    var qmap = _qmap[qkey] || {};
    var qkeys = []; for (var k in qmap) qkeys.push(k); qkeys = qkeys.sort();
    var smry = document.getElementById('summary-table');

    for (var i = 0, e = smry.rows.length; i < e; ++i)
    {
      var r = smry.rows[i];
      var sel = (r.cells[0].textContent == label);
      r.style.borderWidth = "1px";
      r.style.borderStyle = (sel ? "solid" : "none");
      r.style.borderColor = "#ccf";
      r.cells[0].style.fontWeight = (sel ? "bold" : "normal");
    }

    var content = "<div style='padding:1em 2em 0 0; float: left'>"
      + "<table cellpadding='10' style='margin-left:2em; border: none;"
      + " white-space: nowrap; border-collapse: collapse'>"
      + "<thead bgcolor='#f0f0ff'><tr><th>" + _sanitise(qkey)
      + " Part</th><th>Status</th></tr></thead>"
      + "<tbody>";

    var stamp = "";
    for (var i = 0, e = qkeys.length; i < e; ++i)
    {
      var name = qkeys[i];
      if (name == "zzzstamp")
      {
	stamp = ";stamp=" + qmap[name];
	continue;
      }
      var value = qmap[name] * 1.0;
      var color = (value < 0 ? "#000"
		   : (value < 0.85 ? "#a22"
		      : (value < 0.95 ? "#c30" : "#272")));
      var pcolor = (value < 0 ? '#f0f0f0'
		    : (value < 0.85 ? "#fff0f0"
		       : (value < 0.95 ? "#fff0c0" : "#efe")));
      content +=
	"<tr style='background-color:" + pcolor + ";color:" + color + "'>"
	+ "<td style='padding:0 .5em'>" + name + "</td>"
        + "<td align='right' style='padding:0 .5em'>"
        + (value >= 0 ? sprintf("%d%%", Math.round(value * 100))
	   : (value == -1 ? "No DAQ" : "N/A"))
	+ "</td></tr>";
    }
    content += "</tbody></table></div>";

    content += "<div id='smry-qplot' style='padding:1em .25em 0 0'>";
    content += this.qimage(qkey, stamp) + "</div>";
    document.getElementById("qdetail").innerHTML = content;

    if (reset)
      _gui.makeCall(_url() + "/setQualityPlot?n=" + encodeURIComponent(label));

    return false;
  }

  this.qimage = function(label, stamp)
  {
    var hasqplots = (_qavail.length > 0);
    if (label && _qmap[label])
    {
      var relurl = _qrender + "/" + label + "/EventInfo/reportSummaryMap";
      var url = FULLROOTPATH + "/plotfairy/"
	       + encodeURIComponent(relurl).replace(/%2F/g, "/")
	       + "?session=" + SESSION_ID + ";w=532;h=400" + stamp;
      return "<img src='" + url + "' title='" + label + " quality'"
	     + " width='532' height='400'/>";
    }
    else if (hasqplots)
      return "<span style='font-size:95%; color:#888'>(Click on subdetector"
	     + " to show quality data.)</span>";
    else
      return "<span style='font-size:95%; color:#888'>(No further quality"
	     + " data available.)</span>";
  }

  return this;
}();

//////////////////////////////////////////////////////////////////////
GUI.Plugin.DQMQuality = new function()
{
  var _gui		   = null;
  var _canvas              = this;
  var _gcanvas             = document.getElementById('canvas-area');
  var _qrender		   = "";
  var _qavail		   = [];
  var _qmap		   = {};

  this.attach = function(gui)
  {
    _gui = gui;
    _gcanvas.style.bottom = 0;
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.update = function(data)
  {
    _qrender = data.qrender;
    _qavail = [];
    _qmap = {};

    var status = data.items;
    var now = new Date();
    var content = "";

    if (! status.length)
    {
      var content =
        "<div id='no-contents' align='center'"
	+ " style='font-size: 2em; padding: 2em; color: #700'>"
	+ "<p>No DQM sources appear to be running.</p></div>";

      if (_gcanvas.innerHTML != content)
        _gcanvas.innerHTML = content;
    }
    else
    {
      var now = new Date();
      var ets = new Date();
      var item = _gcanvas.firstChild;
      
      if (item && item.id == 'no-contents')
      {
        _gcanvas.removeChild(item);
        item = null;
      }

      for (var i = 0, e = status.length; i < e; ++i, item = item.nextSibling)
      {
        var title;
        if (! item)
	{
	  item = document.createElement("div");
	  title = document.createElement("h3");
	  item.appendChild(title);
	  _gcanvas.appendChild(item);
	}
	else
	{
	  title = item.firstChild;
	  img = title.nextSibling;
	  while (img && img.nextSibling)
	    item.removeChild(img.nextSibling);
	}

	var img = title.nextSibling;
	if (! img)
	{
	  img = document.createElement("img");
	  img.width = 266;
	  img.height = 200;
	  item.appendChild(img);
	}
	else
	  while (img.nextSibling)
	    item.removeChild(img.nextSibling);

        var obj = status[i];
        var color = ((obj.reportSummary == null || obj.reportSummary < 0) ? "#000"
  		     : (obj.reportSummary < 0.85 ? "#a22"
	  		: (obj.reportSummary < 0.95 ? "#c30" : "#272")));
        var bcolor = ((obj.reportSummary == null || obj.reportSummary < 0) ? "#f0f0f0"
  		      : (obj.reportSummary < 0.85 ? "#fff0f0"
		         : (obj.reportSummary < 0.95 ? "#fff0c0" : "#efe")));
	ets.setTime((obj.eventTimeStamp & 0xffffffff) * 1000);

	_settitle(item, "item size-medium", obj.label + " quality report");
	item.style.backgroundColor = bcolor;

	_setval(title, "",
		obj.label + " - "
		+ (obj.reportSummary >= 0 ? sprintf("%.1f%%", obj.reportSummary*100.)
		   : (obj.reportSummary == -1 ? "No DAQ" : "N/A"))
		+ " - " + (obj.eventTimeStamp > 10000 ? _formatTime(ets, now) : "(Never)"));
	title.style.color = color;

	var imgsrc =
	  FULLROOTPATH + "/plotfairy/"
	  + encodeURIComponent(obj.location).replace(/%2F/g, "/") + "/"
	  + encodeURIComponent(obj.name).replace(/%2F/g, "/") + "?"
	  + "session=" + SESSION_ID
	  + ";v=" + obj.version
	  + ";w=266;h=200";
	if (! img.src)
	  img.src = FULLROOTPATH + "/static/blank.gif";
	if (img.src != imgsrc)
	  GUI.ImgLoader.load('dqmq' + i, img, imgsrc);
      }

      while (_gcanvas.childNodes.length > status.length)
        _gcanvas.removeChild(_gcanvas.lastChild);
    }
  }

  return this;
}();

//////////////////////////////////////////////////////////////////////
GUI.Plugin.EVD = new function()
{
  var _gui		   = null;
  var _canvas              = this;
  var _gcanvas             = document.getElementById('canvas-area');

  this.attach = function(gui)
  {
    _gui = gui;
    _gcanvas.style.bottom = 0;
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.image = function(v)
  {
    _gui.makeCall(_url() + "/setPage?page=" + encodeURIComponent(v));
    return false;
  }

  this.date = function(v)
  {
    _gui.makeCall(_url() + "/set?date=" + encodeURIComponent(v));
    return false;
  }

  this.update = function(data)
  {
    var content = "";

    if (data.dates.length)
    {
      content += "<div style='margin:.25em 2em .25em 0'>Dates: ";
      for (var i = 0, e = data.dates.length; i < e; ++i)
        if (data.dates[i] == data.date)
          content += " " + _sanitise(data.dates[i]);
        else
          content += " <a href='#' onclick='return GUI.Plugin.EVD.date(this.textContent)'>"
	    + _sanitise(data.dates[i]) + "</a>";
      content += "</div>";
    }
    else
      content += "<div style='margin:.25em 2em .25em 0'>(No images currently available)</div>";

    if (data.images)
    {
      content += "<div style='margin:.25em 2em .25em 0'>Images: "
        + " <a href='#' onclick='return GUI.Plugin.EVD.image(\"\")'>(Latest)</a>";
      for (var i = data.images; i >= 1; --i)
        if (i == data.curimage)
          content += " " + i.toString();
        else
          content += " <a href='#' onclick='return GUI.Plugin.EVD.image(this.textContent)'>"
	    + i.toString() + "</a>";
      content += "</div>";
    }

    if (data.image)
      content += "<img style='padding:2em 2em 0 2em' src='"
        + FULLROOTPATH + "/plotfairy/iguana-snapshot/"
	+ encodeURIComponent(data.date) + "/"
	+ encodeURIComponent(data.image) + "'>"

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;
  }

  this.qimage = function(label, stamp)
  {
    var hasqplots = (_qavail.length > 0);
    if (label && _qmap[label])
    {
      var relurl = _qrender + "/" + label + "/EventInfo/reportSummaryMap";
      var url = FULLROOTPATH + "/plotfairy/"
	       + encodeURIComponent(relurl).replace(/%2F/g, "/")
	       + "?session=" + SESSION_ID + ";w=532;h=400" + stamp;
      return "<img src='" + url + "' title='" + label + " quality'"
	     + " width='532' height='400'/>";
    }
    else if (hasqplots)
      return "<span style='font-size:95%; color:#888'>(Click on subdetector"
	     + " to show quality data.)</span>";
    else
      return "<span style='font-size:95%; color:#888'>(No further quality"
	     + " data available.)</span>";
  }

  return this;
}();

//////////////////////////////////////////////////////////////////////
GUI.init();

/**
 * sprintf() for JavaScript v.0.4
 *
 * Copyright (c) 2007 Alexandru Marasteanu <http://alexei.417.ro/>
 * Thanks to David Baird (unit test and patch).
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

function str_repeat(i, m) { for (var o = []; m > 0; o[--m] = i); return(o.join('')); }

function sprintf () {
  var i = 0, a, f = arguments[i++], o = [], m, p, c, x;
  while (f) {
    if (m = /^[^\x25]+/.exec(f)) o.push(m[0]);
    else if (m = /^\x25{2}/.exec(f)) o.push('%');
    else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
      if (((a = arguments[m[1] || i++]) == null) || (a == undefined)) throw("Too few arguments.");
      if (/[^s]/.test(m[7]) && (typeof(a) != 'number'))
        throw("Expecting number but found " + typeof(a));
      switch (m[7]) {
        case 'b': a = a.toString(2); break;
        case 'c': a = String.fromCharCode(a); break;
        case 'd': a = parseInt(a); break;
        case 'e': a = m[6] ? a.toExponential(m[6]) : a.toExponential(); break;
        case 'f': a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a); break;
        case 'o': a = a.toString(8); break;
        case 's': a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a); break;
        case 'u': a = Math.abs(a); break;
        case 'x': a = a.toString(16); break;
        case 'X': a = a.toString(16).toUpperCase(); break;
      }
      a = (/[def]/.test(m[7]) && m[2] && a > 0 ? '+' + a : a);
      c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
      x = m[5] - String(a).length;
      p = m[5] ? str_repeat(c, x) : '';
      o.push(m[4] ? a + p : p + a);
    }
    else throw ("Huh ?!");
    f = f.substring(m[0].length);
  }
  return o.join('');
}
